# ConnectionManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getConnectionUsingGET**](ConnectionManagementApi.md#getConnectionUsingGET) | **GET** /api/v1/connections/{connectionId} | Get connection details
[**getRefreshBatchStatusUsingGET**](ConnectionManagementApi.md#getRefreshBatchStatusUsingGET) | **GET** /api/v1/connections/batch/refresh/{batchId} | Gets the status of a batch refresh
[**getRefreshStatusUsingGET**](ConnectionManagementApi.md#getRefreshStatusUsingGET) | **GET** /api/v1/connections/{connectionId}/status | Get connection refresh status
[**listConnectionsUsingGET**](ConnectionManagementApi.md#listConnectionsUsingGET) | **GET** /api/v1/connections | List connections
[**refreshBatchUsingPOST**](ConnectionManagementApi.md#refreshBatchUsingPOST) | **POST** /api/v1/connections/batch/refresh | Refresh batch of connections
[**refreshConnectionUsingPOST**](ConnectionManagementApi.md#refreshConnectionUsingPOST) | **POST** /api/v1/connections/{connectionId}/refresh | Refresh connection


<a name="getConnectionUsingGET"></a>
# **getConnectionUsingGET**
> BaseResponseOfConnectionDto getConnectionUsingGET(connectionId, workspaceId)

Get connection details

Returns details about a specific connection, based on its ID

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ConnectionManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ConnectionManagementApi apiInstance = new ConnectionManagementApi();
String connectionId = "connectionId_example"; // String | The ID of the connection to return details about
String workspaceId = "workspaceId_example"; // String | workspaceId
try {
    BaseResponseOfConnectionDto result = apiInstance.getConnectionUsingGET(connectionId, workspaceId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ConnectionManagementApi#getConnectionUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **connectionId** | **String**| The ID of the connection to return details about |
 **workspaceId** | **String**| workspaceId | [optional]

### Return type

[**BaseResponseOfConnectionDto**](BaseResponseOfConnectionDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getRefreshBatchStatusUsingGET"></a>
# **getRefreshBatchStatusUsingGET**
> BaseResponseOfRefreshBatchDto getRefreshBatchStatusUsingGET(batchId, workspaceId)

Gets the status of a batch refresh

Returns details about a specific batch refresh, based on its ID.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ConnectionManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ConnectionManagementApi apiInstance = new ConnectionManagementApi();
String batchId = "batchId_example"; // String | The ID of the batch to return details about
String workspaceId = "workspaceId_example"; // String | workspaceId
try {
    BaseResponseOfRefreshBatchDto result = apiInstance.getRefreshBatchStatusUsingGET(batchId, workspaceId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ConnectionManagementApi#getRefreshBatchStatusUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **batchId** | **String**| The ID of the batch to return details about |
 **workspaceId** | **String**| workspaceId | [optional]

### Return type

[**BaseResponseOfRefreshBatchDto**](BaseResponseOfRefreshBatchDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getRefreshStatusUsingGET"></a>
# **getRefreshStatusUsingGET**
> BaseResponseOfConnectionRunDto getRefreshStatusUsingGET(connectionId, workspaceId, jobId)

Get connection refresh status

Returns details about a specific connection refresh status, based on its ID. To retrieve details about a specific refresh, provide its &#39;jobId&#39;.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ConnectionManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ConnectionManagementApi apiInstance = new ConnectionManagementApi();
String connectionId = "connectionId_example"; // String | The ID of the connection to return details about
String workspaceId = "workspaceId_example"; // String | workspaceId
String jobId = "jobId_example"; // String | The ID of the job running for a connection
try {
    BaseResponseOfConnectionRunDto result = apiInstance.getRefreshStatusUsingGET(connectionId, workspaceId, jobId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ConnectionManagementApi#getRefreshStatusUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **connectionId** | **String**| The ID of the connection to return details about |
 **workspaceId** | **String**| workspaceId | [optional]
 **jobId** | **String**| The ID of the job running for a connection | [optional]

### Return type

[**BaseResponseOfConnectionRunDto**](BaseResponseOfConnectionRunDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listConnectionsUsingGET"></a>
# **listConnectionsUsingGET**
> PagedResponseOfConnectionDto listConnectionsUsingGET(sourceType, destinationType, sourceId, destinationId, limit, cursor, offset)

List connections

A pageable endpoint to list data connections between features of the Workiva platform

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ConnectionManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ConnectionManagementApi apiInstance = new ConnectionManagementApi();
String sourceType = "sourceType_example"; // String | The type of file or item the connection pulls data from
String destinationType = "destinationType_example"; // String | The type of file or item the connection sends data to
String sourceId = "sourceId_example"; // String | The ID of the file or item the connection pulls data from
String destinationId = "destinationId_example"; // String | The ID of the file or item the connection sends data to
Integer limit = 56; // Integer | The number of connections to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfConnectionDto result = apiInstance.listConnectionsUsingGET(sourceType, destinationType, sourceId, destinationId, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ConnectionManagementApi#listConnectionsUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sourceType** | **String**| The type of file or item the connection pulls data from | [optional] [enum: [spreadsheet, spreadsheet_section, presentation, presentation_chart, presentation_embedded_table, document, document_chart, document_embedded_table, wdata_query, wdata_table, wdata_table_dataset, report]]
 **destinationType** | **String**| The type of file or item the connection sends data to | [optional] [enum: [spreadsheet, spreadsheet_section, presentation, presentation_chart, presentation_embedded_table, document, document_chart, document_embedded_table, wdata_query, wdata_table, wdata_table_dataset, report]]
 **sourceId** | **String**| The ID of the file or item the connection pulls data from | [optional]
 **destinationId** | **String**| The ID of the file or item the connection sends data to | [optional]
 **limit** | **Integer**| The number of connections to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfConnectionDto**](PagedResponseOfConnectionDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="refreshBatchUsingPOST"></a>
# **refreshBatchUsingPOST**
> BaseResponseOfRefreshBatchDto refreshBatchUsingPOST(refreshConnectionDtos)

Refresh batch of connections

Refreshes multiple connections at once, based on their IDs

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ConnectionManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ConnectionManagementApi apiInstance = new ConnectionManagementApi();
List<RefreshConnectionDto> refreshConnectionDtos = Arrays.asList(new RefreshConnectionDto()); // List<RefreshConnectionDto> | refreshConnectionDtos
try {
    BaseResponseOfRefreshBatchDto result = apiInstance.refreshBatchUsingPOST(refreshConnectionDtos);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ConnectionManagementApi#refreshBatchUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **refreshConnectionDtos** | [**List&lt;RefreshConnectionDto&gt;**](RefreshConnectionDto.md)| refreshConnectionDtos |

### Return type

[**BaseResponseOfRefreshBatchDto**](BaseResponseOfRefreshBatchDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="refreshConnectionUsingPOST"></a>
# **refreshConnectionUsingPOST**
> BaseResponseOfConnectionRunDto refreshConnectionUsingPOST(connectionId, refreshConnectionDto)

Refresh connection

Refreshes a specific connection, based on its ID

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.ConnectionManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

ConnectionManagementApi apiInstance = new ConnectionManagementApi();
String connectionId = "connectionId_example"; // String | The ID of the connection to refresh
RefreshConnectionDto refreshConnectionDto = new RefreshConnectionDto(); // RefreshConnectionDto | refreshConnectionDto
try {
    BaseResponseOfConnectionRunDto result = apiInstance.refreshConnectionUsingPOST(connectionId, refreshConnectionDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ConnectionManagementApi#refreshConnectionUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **connectionId** | **String**| The ID of the connection to refresh |
 **refreshConnectionDto** | [**RefreshConnectionDto**](RefreshConnectionDto.md)| refreshConnectionDto |

### Return type

[**BaseResponseOfConnectionRunDto**](BaseResponseOfConnectionRunDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

