# FolderManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createFolderUsingPOST**](FolderManagementApi.md#createFolderUsingPOST) | **POST** /api/v1/folder | Create a new folder
[**deleteFolderUsingDELETE**](FolderManagementApi.md#deleteFolderUsingDELETE) | **DELETE** /api/v1/folder/{folderId} | Delete a single folder
[**getFolderUsingGET**](FolderManagementApi.md#getFolderUsingGET) | **GET** /api/v1/folder/{folderId} | Retrieve a single folder
[**listChildrenUsingGET**](FolderManagementApi.md#listChildrenUsingGET) | **GET** /api/v1/folder/{folderId}/children | Retrieve list of folder contents
[**listFoldersUsingGET**](FolderManagementApi.md#listFoldersUsingGET) | **GET** /api/v1/folder | Retrieve a list of folders
[**searchUsingGET**](FolderManagementApi.md#searchUsingGET) | **GET** /api/v1/entity | Search
[**setChildrenUsingPOST**](FolderManagementApi.md#setChildrenUsingPOST) | **POST** /api/v1/folder/{folderId}/children | Move content into a folder
[**updateFolderUsingPUT**](FolderManagementApi.md#updateFolderUsingPUT) | **PUT** /api/v1/folder/{folderId} | Update a single folder


<a name="createFolderUsingPOST"></a>
# **createFolderUsingPOST**
> BaseResponseOfFolderDto createFolderUsingPOST(folderDto)

Create a new folder

Creates a folder using the provided information and returns the folder meta.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
FolderDto folderDto = new FolderDto(); // FolderDto | The representation of the folder to create
try {
    BaseResponseOfFolderDto result = apiInstance.createFolderUsingPOST(folderDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#createFolderUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderDto** | [**FolderDto**](FolderDto.md)| The representation of the folder to create | [optional]

### Return type

[**BaseResponseOfFolderDto**](BaseResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteFolderUsingDELETE"></a>
# **deleteFolderUsingDELETE**
> BaseResponseOfstring deleteFolderUsingDELETE(folderId)

Delete a single folder

Deletes the folder with the provided ID.  If the folder is not found, this is a no-op. &lt;b&gt;All files and sub-folders are also recursively deleted.&lt;/b&gt;

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
String folderId = "folderId_example"; // String | The unique identifier of the folder
try {
    BaseResponseOfstring result = apiInstance.deleteFolderUsingDELETE(folderId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#deleteFolderUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **String**| The unique identifier of the folder |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="getFolderUsingGET"></a>
# **getFolderUsingGET**
> BaseResponseOfFolderDto getFolderUsingGET(folderId)

Retrieve a single folder

Returns a folder with the provided ID, or a 404 if no matching folder is found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
String folderId = "folderId_example"; // String | The unique identifier of the folder
try {
    BaseResponseOfFolderDto result = apiInstance.getFolderUsingGET(folderId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#getFolderUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **String**| The unique identifier of the folder |

### Return type

[**BaseResponseOfFolderDto**](BaseResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listChildrenUsingGET"></a>
# **listChildrenUsingGET**
> PagedResponseOfFolderableDto listChildrenUsingGET(folderId, limit, cursor, offset)

Retrieve list of folder contents

Returns a paged list of all children whose parent ID matches the provided folder ID.  If the folder ID in the path is the literal &#39;null&#39; value, returns a list of all entities with no parent.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
String folderId = "folderId_example"; // String | The unique identifier of the folder
Integer limit = 56; // Integer | The number of folders to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfFolderableDto result = apiInstance.listChildrenUsingGET(folderId, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#listChildrenUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **String**| The unique identifier of the folder |
 **limit** | **Integer**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfFolderableDto**](PagedResponseOfFolderableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listFoldersUsingGET"></a>
# **listFoldersUsingGET**
> PagedResponseOfFolderDto listFoldersUsingGET(limit, cursor, offset)

Retrieve a list of folders

Returns a paged list of all folders associated with the workspace.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
Integer limit = 56; // Integer | The number of folders to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfFolderDto result = apiInstance.listFoldersUsingGET(limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#listFoldersUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **Integer**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfFolderDto**](PagedResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="searchUsingGET"></a>
# **searchUsingGET**
> PagedResponseOfFolderableDto searchUsingGET(name, description, type, limit, cursor, offset)

Search

Returns a list of all entities that match the provided criteria. Both name and description are fuzzy matches; they match _any_ entity that contains the provided string. The type is used to filter results based on the provided type of entity.  The consumer must have READ access on all returned entities.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
String name = "name_example"; // String | The name to use when fuzzy-matching entities
String description = "description_example"; // String | The description to use when fuzzy-matching entities
List<Integer> type = Arrays.asList(56); // List<Integer> | To limit the scope, the type of entity to return in the results
Integer limit = 56; // Integer | The number of folders to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfFolderableDto result = apiInstance.searchUsingGET(name, description, type, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#searchUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**| The name to use when fuzzy-matching entities | [optional]
 **description** | **String**| The description to use when fuzzy-matching entities | [optional]
 **type** | [**List&lt;Integer&gt;**](Integer.md)| To limit the scope, the type of entity to return in the results | [optional]
 **limit** | **Integer**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfFolderableDto**](PagedResponseOfFolderableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="setChildrenUsingPOST"></a>
# **setChildrenUsingPOST**
> BaseResponseOfCollectionOfFolderableDto setChildrenUsingPOST(folderId, children)

Move content into a folder

Sets the children of a folder using the entities&#39; types and IDs provided in the body. If the entities previously resided under a folder, including the root, they move to the folder with the provided ID. If the provided ID is &#39;null&#39;, the entities move to the root folder.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
String folderId = "folderId_example"; // String | The unique identifier of the folder
List<FolderableDto> children = Arrays.asList(new FolderableDto()); // List<FolderableDto> | The representation of the entities to drop into the folder
try {
    BaseResponseOfCollectionOfFolderableDto result = apiInstance.setChildrenUsingPOST(folderId, children);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#setChildrenUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **String**| The unique identifier of the folder |
 **children** | [**List&lt;FolderableDto&gt;**](FolderableDto.md)| The representation of the entities to drop into the folder | [optional]

### Return type

[**BaseResponseOfCollectionOfFolderableDto**](BaseResponseOfCollectionOfFolderableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateFolderUsingPUT"></a>
# **updateFolderUsingPUT**
> BaseResponseOfFolderDto updateFolderUsingPUT(folderId, folderDto)

Update a single folder

Updates the folder that matches the provided ID with the details provided in the body.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FolderManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

FolderManagementApi apiInstance = new FolderManagementApi();
String folderId = "folderId_example"; // String | The unique identifier of the folder
FolderDto folderDto = new FolderDto(); // FolderDto | The representation of the folder to update
try {
    BaseResponseOfFolderDto result = apiInstance.updateFolderUsingPUT(folderId, folderDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FolderManagementApi#updateFolderUsingPUT");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **String**| The unique identifier of the folder |
 **folderDto** | [**FolderDto**](FolderDto.md)| The representation of the folder to update | [optional]

### Return type

[**BaseResponseOfFolderDto**](BaseResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

