# QueryManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**cancelQueryUsingDELETE**](QueryManagementApi.md#cancelQueryUsingDELETE) | **DELETE** /api/v1/queryresult/{queryResultId} | Cancel a running query
[**createQueryUsingPOST**](QueryManagementApi.md#createQueryUsingPOST) | **POST** /api/v1/query | Create a new query
[**deleteQueryUsingDELETE**](QueryManagementApi.md#deleteQueryUsingDELETE) | **DELETE** /api/v1/query/{queryId} | Delete a single query
[**downloadQueryResultUsingGET**](QueryManagementApi.md#downloadQueryResultUsingGET) | **GET** /api/v1/queryresult/{queryResultId}/download | Download a query result
[**exportQueryResultToSpreadsheetsUsingPOST**](QueryManagementApi.md#exportQueryResultToSpreadsheetsUsingPOST) | **POST** /api/v1/queryresult/{queryResultId}/export | Export query result to spreadsheets
[**getDependenciesUsingGET**](QueryManagementApi.md#getDependenciesUsingGET) | **GET** /api/v1/query/{queryId}/dependencies | Retrieve dependencies
[**getQueryColumnDataUsingPOST**](QueryManagementApi.md#getQueryColumnDataUsingPOST) | **POST** /api/v1/query/data | Retrieve query column data
[**getQueryResultUsingGET**](QueryManagementApi.md#getQueryResultUsingGET) | **GET** /api/v1/queryresult/{queryResultId} | Retrieve a single query result
[**getQueryUsingGET**](QueryManagementApi.md#getQueryUsingGET) | **GET** /api/v1/query/{queryId} | Retrieve a single query
[**getTablesDependentOnQueryUsingGET**](QueryManagementApi.md#getTablesDependentOnQueryUsingGET) | **GET** /api/v1/query/{queryId}/dependents | Retrieve a list of dependents
[**isQueryValidUsingPOST**](QueryManagementApi.md#isQueryValidUsingPOST) | **POST** /api/v1/query/validation | Parses the query to determine if it is valid
[**listQueriesUsingGET**](QueryManagementApi.md#listQueriesUsingGET) | **GET** /api/v1/query | Retrieve list of queries
[**listQueryResultsUsingGET**](QueryManagementApi.md#listQueryResultsUsingGET) | **GET** /api/v1/queryresult | Retrieve a list of query results
[**previewQueryUsingPOST**](QueryManagementApi.md#previewQueryUsingPOST) | **POST** /api/v1/query/preview/{tableId} | Preview a query
[**runQueryUsingPOST**](QueryManagementApi.md#runQueryUsingPOST) | **POST** /api/v1/queryresult | Execute a query
[**updateQueryUsingPUT**](QueryManagementApi.md#updateQueryUsingPUT) | **PUT** /api/v1/query/{queryId} | Update a single query


<a name="cancelQueryUsingDELETE"></a>
# **cancelQueryUsingDELETE**
> BaseResponseOfQueryResultDto cancelQueryUsingDELETE(queryResultId)

Cancel a running query

Cancels a running query based on the provided result ID, and returns a cancelled result unless the query&#39;s already in a COMPLETED state.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryResultId = "queryResultId_example"; // String | The unique identifier of the query result
try {
    BaseResponseOfQueryResultDto result = apiInstance.cancelQueryUsingDELETE(queryResultId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#cancelQueryUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **String**| The unique identifier of the query result |

### Return type

[**BaseResponseOfQueryResultDto**](BaseResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="createQueryUsingPOST"></a>
# **createQueryUsingPOST**
> BaseResponseOfQueryDto createQueryUsingPOST(queryDto)

Create a new query

Creates a query object and validates full permissions to ensure the requestor has access to all data sources being queried. This endpoint _doesn&#39;t_ execute the query; to execute, call the POST /queryresult method.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
QueryDto queryDto = new QueryDto(); // QueryDto | The representation of the query to create
try {
    BaseResponseOfQueryDto result = apiInstance.createQueryUsingPOST(queryDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#createQueryUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryDto** | [**QueryDto**](QueryDto.md)| The representation of the query to create | [optional]

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteQueryUsingDELETE"></a>
# **deleteQueryUsingDELETE**
> BaseResponseOfstring deleteQueryUsingDELETE(queryId)

Delete a single query

Deletes the query that matches the provided ID. If no such query is found, this is a no-op.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryId = "queryId_example"; // String | The unique identifier of the query
try {
    BaseResponseOfstring result = apiInstance.deleteQueryUsingDELETE(queryId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#deleteQueryUsingDELETE");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **String**| The unique identifier of the query |

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="downloadQueryResultUsingGET"></a>
# **downloadQueryResultUsingGET**
> byte[] downloadQueryResultUsingGET(queryResultId)

Download a query result

Uses the Token Management API to create a token with the query result ID, which it then uses to download a CSV file of the query results.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryResultId = "queryResultId_example"; // String | The unique identifier of the query result
try {
    byte[] result = apiInstance.downloadQueryResultUsingGET(queryResultId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#downloadQueryResultUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **String**| The unique identifier of the query result |

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="exportQueryResultToSpreadsheetsUsingPOST"></a>
# **exportQueryResultToSpreadsheetsUsingPOST**
> BaseResponseOfstring exportQueryResultToSpreadsheetsUsingPOST(queryResultId, dto)

Export query result to spreadsheets

Exports a query result with the provided ID to Spreadsheets. To determine where to export the results, the request body should include a URL copied and pasted from the Spreadsheets UI. Returns a 404 if no matching query result is found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryResultId = "queryResultId_example"; // String | The unique identifier of the query result
ExportQueryResultDto dto = new ExportQueryResultDto(); // ExportQueryResultDto | The representation of the export query result
try {
    BaseResponseOfstring result = apiInstance.exportQueryResultToSpreadsheetsUsingPOST(queryResultId, dto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#exportQueryResultToSpreadsheetsUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **String**| The unique identifier of the query result |
 **dto** | [**ExportQueryResultDto**](ExportQueryResultDto.md)| The representation of the export query result | [optional]

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getDependenciesUsingGET"></a>
# **getDependenciesUsingGET**
> PagedResponseOfTableDto getDependenciesUsingGET(queryId, limit, cursor, offset)

Retrieve dependencies

Returns an unordered collection of all tables the matching query uses as datasources, including any shared tables outside of this OAuth token&#39;s workspace. The endpoint verifies the user has read permissions on the query, but _not_ on the tables returned.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryId = "queryId_example"; // String | The unique identifier of the query
Integer limit = 56; // Integer | The number of dependencies to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfTableDto result = apiInstance.getDependenciesUsingGET(queryId, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#getDependenciesUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **String**| The unique identifier of the query |
 **limit** | **Integer**| The number of dependencies to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfTableDto**](PagedResponseOfTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getQueryColumnDataUsingPOST"></a>
# **getQueryColumnDataUsingPOST**
> BaseResponseOfQueryColumnDataDto getQueryColumnDataUsingPOST(queryTextDto)

Retrieve query column data

Returns a QueryColumnDataDto representing the column data for the given query text. If the query isn&#39;t valid, returns a 400.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
QueryTextDto queryTextDto = new QueryTextDto(); // QueryTextDto | The query text to parse, up to 30000 characters; must not be null or empty
try {
    BaseResponseOfQueryColumnDataDto result = apiInstance.getQueryColumnDataUsingPOST(queryTextDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#getQueryColumnDataUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryTextDto** | [**QueryTextDto**](QueryTextDto.md)| The query text to parse, up to 30000 characters; must not be null or empty |

### Return type

[**BaseResponseOfQueryColumnDataDto**](BaseResponseOfQueryColumnDataDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getQueryResultUsingGET"></a>
# **getQueryResultUsingGET**
> BaseResponseOfQueryResultDto getQueryResultUsingGET(queryResultId)

Retrieve a single query result

Returns a single query result that matches the provided ID, or a 404 if no such query result is found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryResultId = "queryResultId_example"; // String | The unique identifier of the query result
try {
    BaseResponseOfQueryResultDto result = apiInstance.getQueryResultUsingGET(queryResultId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#getQueryResultUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **String**| The unique identifier of the query result |

### Return type

[**BaseResponseOfQueryResultDto**](BaseResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getQueryUsingGET"></a>
# **getQueryUsingGET**
> BaseResponseOfQueryDto getQueryUsingGET(queryId)

Retrieve a single query

Returns a query that matches the provided ID, or a 404 if no matching query is found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryId = "queryId_example"; // String | The unique identifier of the query
try {
    BaseResponseOfQueryDto result = apiInstance.getQueryUsingGET(queryId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#getQueryUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **String**| The unique identifier of the query |

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getTablesDependentOnQueryUsingGET"></a>
# **getTablesDependentOnQueryUsingGET**
> PagedResponseOfTableDto getTablesDependentOnQueryUsingGET(queryId, limit, cursor, offset)

Retrieve a list of dependents

Returns a list of all tables that use the query with provided ID as a datasource. 

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryId = "queryId_example"; // String | The unique identifier of the query
Integer limit = 56; // Integer | The number of folders to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfTableDto result = apiInstance.getTablesDependentOnQueryUsingGET(queryId, limit, cursor, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#getTablesDependentOnQueryUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **String**| The unique identifier of the query |
 **limit** | **Integer**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]

### Return type

[**PagedResponseOfTableDto**](PagedResponseOfTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

<a name="isQueryValidUsingPOST"></a>
# **isQueryValidUsingPOST**
> BaseResponseOfQueryDto isQueryValidUsingPOST(queryDto)

Parses the query to determine if it is valid

Returns the provided QueryDto

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
QueryDto queryDto = new QueryDto(); // QueryDto | The representation of the created query
try {
    BaseResponseOfQueryDto result = apiInstance.isQueryValidUsingPOST(queryDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#isQueryValidUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryDto** | [**QueryDto**](QueryDto.md)| The representation of the created query | [optional]

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listQueriesUsingGET"></a>
# **listQueriesUsingGET**
> PagedResponseOfQueryDto listQueriesUsingGET(limit, cursor, offset, ids)

Retrieve list of queries

Returns a list of all non-temporary queries associated with the workspace. By default, these queries are ordered by their names, in ascending order.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
Integer limit = 56; // Integer | The number of queries to return, from 1 to 1000; by default, 1000
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Long offset = 789L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
Object ids = null; // Object | A list of ids to filter the returned list by
try {
    PagedResponseOfQueryDto result = apiInstance.listQueriesUsingGET(limit, cursor, offset, ids);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#listQueriesUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **Integer**| The number of queries to return, from 1 to 1000; by default, 1000 | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional]
 **ids** | [**Object**](.md)| A list of ids to filter the returned list by | [optional]

### Return type

[**PagedResponseOfQueryDto**](PagedResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="listQueryResultsUsingGET"></a>
# **listQueryResultsUsingGET**
> PagedResponseOfQueryResultDto listQueryResultsUsingGET(queryId, cursor, limit, offset)

Retrieve a list of query results

Returns a paged list of query results that match the provided query ID, or an empty list if no matching query is found.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryId = "queryId_example"; // String | The unique identifier of the query
String cursor = "cursor_example"; // String | A paging cursor; if included, `limit` is ignored
Integer limit = 1000; // Integer | The number of query results to return, from 1 to 1000; by default, 1000
Long offset = 0L; // Long | The item to start with on the page, greater than or equal to 0; by default, 0
try {
    PagedResponseOfQueryResultDto result = apiInstance.listQueryResultsUsingGET(queryId, cursor, limit, offset);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#listQueryResultsUsingGET");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **String**| The unique identifier of the query | [optional]
 **cursor** | **String**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional]
 **limit** | **Integer**| The number of query results to return, from 1 to 1000; by default, 1000 | [optional] [default to 1000]
 **offset** | **Long**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] [default to 0]

### Return type

[**PagedResponseOfQueryResultDto**](PagedResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="previewQueryUsingPOST"></a>
# **previewQueryUsingPOST**
> BaseResponseOfQueryDto previewQueryUsingPOST(tableId, limit, fileName)

Preview a query

Creates a limited scope query object, but does _not_ execute it. The query selects all values against the provided table, up to 10 rows. This endpoint may allow unpermissioned users to preview table data; full permissions to datasources are _not_ validated.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String tableId = "tableId_example"; // String | The identifier of the table to query
Integer limit = 56; // Integer | The number of rows to return
String fileName = "fileName_example"; // String | The name of the file to create
try {
    BaseResponseOfQueryDto result = apiInstance.previewQueryUsingPOST(tableId, limit, fileName);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#previewQueryUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **String**| The identifier of the table to query |
 **limit** | **Integer**| The number of rows to return | [optional]
 **fileName** | **String**| The name of the file to create | [optional]

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="runQueryUsingPOST"></a>
# **runQueryUsingPOST**
> BaseResponseOfQueryResultDto runQueryUsingPOST(queryResultDto)

Execute a query

Runs a query and immediately returns a query result entity, which has an ID that can be used to poll the status from the GET /queryresult method. A status of COMPLETED or ERROR indicates the query has completed.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
QueryResultDto queryResultDto = new QueryResultDto(); // QueryResultDto | The representation of the created query
try {
    BaseResponseOfQueryResultDto result = apiInstance.runQueryUsingPOST(queryResultDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#runQueryUsingPOST");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultDto** | [**QueryResultDto**](QueryResultDto.md)| The representation of the created query | [optional]

### Return type

[**BaseResponseOfQueryResultDto**](BaseResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateQueryUsingPUT"></a>
# **updateQueryUsingPUT**
> BaseResponseOfQueryDto updateQueryUsingPUT(queryId, queryDto)

Update a single query

Updates the query that matches the provided ID with the details provided in the body.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.QueryManagementApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure OAuth2 access token for authorization: oauth
OAuth oauth = (OAuth) defaultClient.getAuthentication("oauth");
oauth.setAccessToken("YOUR ACCESS TOKEN");

QueryManagementApi apiInstance = new QueryManagementApi();
String queryId = "queryId_example"; // String | The unique identifier of the query
QueryDto queryDto = new QueryDto(); // QueryDto | The representation of the query to update
try {
    BaseResponseOfQueryDto result = apiInstance.updateQueryUsingPUT(queryId, queryDto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QueryManagementApi#updateQueryUsingPUT");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **String**| The unique identifier of the query |
 **queryDto** | [**QueryDto**](QueryDto.md)| The representation of the query to update | [optional]

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

