
# QueryResultDto

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**bytesScanned** | **Long** | The number of bytes scanned |  [optional]
**columns** | [**List&lt;ColumnInfoDto&gt;**](ColumnInfoDto.md) | If the query has successfully completed, contains a list of columns and their associated computed types from the query. |  [optional]
**created** | [**DateTime**](DateTime.md) | When the entity was created |  [optional]
**duration** | **Long** | The duration of time it took to execute the query |  [optional]
**error** | **String** | If an error was encountered during the query, this field will be populated with error text. |  [optional]
**id** | **String** | The entity&#39;s unique identifier |  [optional]
**isExplain** | **Boolean** | Determines if this query is to be explained and not executed |  [optional]
**parameters** | **Map&lt;String, Object&gt;** | The query parameter map |  [optional]
**pivotStatus** | [**PivotStatusEnum**](#PivotStatusEnum) | The current status of the pivot execution |  [optional]
**queryDto** | [**QueryDto**](QueryDto.md) | Associated queryDto |  [optional]
**queryId** | **String** | The identifier of the original query |  [optional]
**queryParameters** | [**List&lt;QueryParameterDto&gt;**](QueryParameterDto.md) | Contains the parameters available to the query at the time it was run. This allows consumers to go back in time and view the state of the query at runtime. For older query runs, this value may not be populated. |  [optional]
**queryText** | **String** |  |  [optional]
**rowsReturned** | **Long** | Contains the number of rows returned from the query. |  [optional]
**size** | **Long** | Contains the size of the query results in bytes. This can be used to determine how best to download the file and if it&#39;s reasonable to open it in a browser or other application. This may be 0 if there are no results or the query results were gathered before we started collecting this metric. |  [optional]
**status** | [**StatusEnum**](#StatusEnum) | The current status of the query execution |  [optional]
**updated** | [**DateTime**](DateTime.md) | When the entity was last updated |  [optional]
**userId** | **String** | The owner of the entity |  [optional]
**version** | **Long** | The version of the current representation of the entity |  [optional]


<a name="PivotStatusEnum"></a>
## Enum: PivotStatusEnum
Name | Value
---- | -----
NOT_STARTED | &quot;NOT_STARTED&quot;
RUNNING | &quot;RUNNING&quot;
COMPLETE | &quot;COMPLETE&quot;
ERROR | &quot;ERROR&quot;
CANCELLED | &quot;CANCELLED&quot;
RUNNING_QUERY | &quot;RUNNING_QUERY&quot;
PIVOT_QUEUED | &quot;PIVOT_QUEUED&quot;
RUNNING_PIVOT | &quot;RUNNING_PIVOT&quot;
QUERY_COMPLETE | &quot;QUERY_COMPLETE&quot;
NOT_APPLICABLE | &quot;NOT_APPLICABLE&quot;
PIVOT_ERROR | &quot;PIVOT_ERROR&quot;


<a name="StatusEnum"></a>
## Enum: StatusEnum
Name | Value
---- | -----
NOT_STARTED | &quot;NOT_STARTED&quot;
RUNNING | &quot;RUNNING&quot;
COMPLETE | &quot;COMPLETE&quot;
ERROR | &quot;ERROR&quot;
CANCELLED | &quot;CANCELLED&quot;



