
# TableDto

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**created** | [**DateTime**](DateTime.md) | When the entity was created |  [optional]
**databaseId** | **String** | The unique identifier of the database where the table resides. |  [optional]
**datasetUpdated** | [**DateTime**](DateTime.md) | The last time that the data set for this table was modified. |  [optional]
**deleted** | **Boolean** | This is for backwards compatibility only and will always return false. |  [optional]
**description** | **String** | May be at most 255 characters in length |  [optional]
**id** | **String** | The entity&#39;s unique identifier |  [optional]
**isShared** | **Boolean** | A property indicating if this table is shared to any destination. | 
**lastUploaded** | [**DateTime**](DateTime.md) | Contains the date and time of the last file that was imported into the table. Valuable for determining if the data is stale. |  [optional]
**name** | **String** | May be at most 150 characters in length |  [optional]
**parentId** | **String** | If non-null, indicates the parent of this entity. Must be modified through the folder api. |  [optional]
**readOnly** | **Boolean** | Indicates if this table is readonly in the account receiving this table. If so, any attempt to edit the table will fail. |  [optional]
**tableSchema** | [**TableSchema**](TableSchema.md) | The schema to apply |  [optional]
**type** | [**TypeEnum**](#TypeEnum) | The type of table |  [optional]
**uniqueTableConstraints** | [**List&lt;UniqueConstraintDto&gt;**](UniqueConstraintDto.md) | A property indicating the unique constraints on the table. | 
**updated** | [**DateTime**](DateTime.md) | When the entity was last updated |  [optional]
**userId** | **String** | The owner of the entity |  [optional]
**version** | **Long** | The version of the current representation of the entity |  [optional]


<a name="TypeEnum"></a>
## Enum: TypeEnum
Name | Value
---- | -----
DATA | &quot;data&quot;
LOOKUP | &quot;lookup&quot;



