/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.BaseResponseOfTokenDto;
import io.swagger.client.model.PagedResponseOfFileMetaDto;
import io.swagger.client.model.BaseResponseOflong;
import java.io.File;
import io.swagger.client.model.BaseResponseOfValidateFilesDto;
import io.swagger.client.model.StartValidateFilesDto;
import io.swagger.client.model.BaseResponseOfValidateTablesDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AdministrativeTasksApi {
    private ApiClient apiClient;

    public AdministrativeTasksApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AdministrativeTasksApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for deleteWorkspaceUsingDELETE */
    private com.squareup.okhttp.Call deleteWorkspaceUsingDELETECall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/account".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single workspace
     * Deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone&lt;/b&gt;. Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes.
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteWorkspaceUsingDELETE() throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteWorkspaceUsingDELETEWithHttpInfo();
        return resp.getData();
    }

    /**
     * Delete a single workspace
     * Deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone&lt;/b&gt;. Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes.
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteWorkspaceUsingDELETEWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = deleteWorkspaceUsingDELETECall(null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single workspace (asynchronously)
     * Deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone&lt;/b&gt;. Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes.
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteWorkspaceUsingDELETEAsync(final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteWorkspaceUsingDELETECall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for exportWorkspaceUsingGET */
    private com.squareup.okhttp.Call exportWorkspaceUsingGETCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/export".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Export a single workspace
     * Creates a file representing the entirety of the requested workspace and returns a token. Use the [&#x60;Download a single file endpoint&#x60;](ref:wdata-downloadfileusingget) to exchange the token for the file.
     * @return BaseResponseOfTokenDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfTokenDto exportWorkspaceUsingGET() throws ApiException {
        ApiResponse<BaseResponseOfTokenDto> resp = exportWorkspaceUsingGETWithHttpInfo();
        return resp.getData();
    }

    /**
     * Export a single workspace
     * Creates a file representing the entirety of the requested workspace and returns a token. Use the [&#x60;Download a single file endpoint&#x60;](ref:wdata-downloadfileusingget) to exchange the token for the file.
     * @return ApiResponse&lt;BaseResponseOfTokenDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfTokenDto> exportWorkspaceUsingGETWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = exportWorkspaceUsingGETCall(null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfTokenDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Export a single workspace (asynchronously)
     * Creates a file representing the entirety of the requested workspace and returns a token. Use the [&#x60;Download a single file endpoint&#x60;](ref:wdata-downloadfileusingget) to exchange the token for the file.
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call exportWorkspaceUsingGETAsync(final ApiCallback<BaseResponseOfTokenDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = exportWorkspaceUsingGETCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfTokenDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for findWorkspaceFilesBySizeUsingGET */
    private com.squareup.okhttp.Call findWorkspaceFilesBySizeUsingGETCall(Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/usage/filesBySize".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve workspace files by size
     * Returns a paged collection of the file meta associated with the workspace of the request, ordered by size.
     * @param limit The number of file meta objects to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfFileMetaDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfFileMetaDto findWorkspaceFilesBySizeUsingGET(Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfFileMetaDto> resp = findWorkspaceFilesBySizeUsingGETWithHttpInfo(limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve workspace files by size
     * Returns a paged collection of the file meta associated with the workspace of the request, ordered by size.
     * @param limit The number of file meta objects to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfFileMetaDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfFileMetaDto> findWorkspaceFilesBySizeUsingGETWithHttpInfo(Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = findWorkspaceFilesBySizeUsingGETCall(limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfFileMetaDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve workspace files by size (asynchronously)
     * Returns a paged collection of the file meta associated with the workspace of the request, ordered by size.
     * @param limit The number of file meta objects to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call findWorkspaceFilesBySizeUsingGETAsync(Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfFileMetaDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = findWorkspaceFilesBySizeUsingGETCall(limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfFileMetaDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getWorkspaceQueryUsageUsingGET */
    private com.squareup.okhttp.Call getWorkspaceQueryUsageUsingGETCall(String startDate, String stopDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/usage/query".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "startDate", startDate));
        if (stopDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "stopDate", stopDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve workspace query usage
     * Returns a Long that represents the number of bytes queried by the workspace of the request since the start time provided.
     * @param startDate The earliest date of usage to consider (optional, default to 1970-01-01)
     * @param stopDate The end date of usage to consider (optional, default to 9999-01-01)
     * @return BaseResponseOflong
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOflong getWorkspaceQueryUsageUsingGET(String startDate, String stopDate) throws ApiException {
        ApiResponse<BaseResponseOflong> resp = getWorkspaceQueryUsageUsingGETWithHttpInfo(startDate, stopDate);
        return resp.getData();
    }

    /**
     * Retrieve workspace query usage
     * Returns a Long that represents the number of bytes queried by the workspace of the request since the start time provided.
     * @param startDate The earliest date of usage to consider (optional, default to 1970-01-01)
     * @param stopDate The end date of usage to consider (optional, default to 9999-01-01)
     * @return ApiResponse&lt;BaseResponseOflong&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOflong> getWorkspaceQueryUsageUsingGETWithHttpInfo(String startDate, String stopDate) throws ApiException {
        com.squareup.okhttp.Call call = getWorkspaceQueryUsageUsingGETCall(startDate, stopDate, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOflong>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve workspace query usage (asynchronously)
     * Returns a Long that represents the number of bytes queried by the workspace of the request since the start time provided.
     * @param startDate The earliest date of usage to consider (optional, default to 1970-01-01)
     * @param stopDate The end date of usage to consider (optional, default to 9999-01-01)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getWorkspaceQueryUsageUsingGETAsync(String startDate, String stopDate, final ApiCallback<BaseResponseOflong> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getWorkspaceQueryUsageUsingGETCall(startDate, stopDate, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOflong>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getWorkspaceUploadUsageUsingGET */
    private com.squareup.okhttp.Call getWorkspaceUploadUsageUsingGETCall(String startDate, String stopDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/usage/upload".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (startDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "startDate", startDate));
        if (stopDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "stopDate", stopDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve workspace upload usage
     * Returns a Long that represents the number of bytes uploaded by the workspace associated with this request from the start time provided to now.
     * @param startDate The starting point to begin considering usage (optional, default to 1970-01-01)
     * @param stopDate The ending point when considering usage (optional, default to 9999-01-01)
     * @return BaseResponseOflong
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOflong getWorkspaceUploadUsageUsingGET(String startDate, String stopDate) throws ApiException {
        ApiResponse<BaseResponseOflong> resp = getWorkspaceUploadUsageUsingGETWithHttpInfo(startDate, stopDate);
        return resp.getData();
    }

    /**
     * Retrieve workspace upload usage
     * Returns a Long that represents the number of bytes uploaded by the workspace associated with this request from the start time provided to now.
     * @param startDate The starting point to begin considering usage (optional, default to 1970-01-01)
     * @param stopDate The ending point when considering usage (optional, default to 9999-01-01)
     * @return ApiResponse&lt;BaseResponseOflong&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOflong> getWorkspaceUploadUsageUsingGETWithHttpInfo(String startDate, String stopDate) throws ApiException {
        com.squareup.okhttp.Call call = getWorkspaceUploadUsageUsingGETCall(startDate, stopDate, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOflong>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve workspace upload usage (asynchronously)
     * Returns a Long that represents the number of bytes uploaded by the workspace associated with this request from the start time provided to now.
     * @param startDate The starting point to begin considering usage (optional, default to 1970-01-01)
     * @param stopDate The ending point when considering usage (optional, default to 9999-01-01)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getWorkspaceUploadUsageUsingGETAsync(String startDate, String stopDate, final ApiCallback<BaseResponseOflong> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getWorkspaceUploadUsageUsingGETCall(startDate, stopDate, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOflong>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for importDataUsingPOST */
    private com.squareup.okhttp.Call importDataUsingPOSTCall(File file, Boolean wipe, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/import".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (wipe != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "wipe", wipe));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (file != null)
        localVarFormParams.put("file", file);

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Import data
     * By default, deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone.&lt;/b&gt;  Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes. After the delete, it then imports the tables, tags, and queries in the provided cb file into the workspace. &lt;br&gt;&lt;br&gt;This is an asynchronous operation. Returns a 201 when the file is correctly decoded and its tables, queries, and tags are saved. Files continue to import after this call completes.
     * @param file The file containing workspace information to import (optional)
     * @param wipe wipe (optional, default to true)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring importDataUsingPOST(File file, Boolean wipe) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = importDataUsingPOSTWithHttpInfo(file, wipe);
        return resp.getData();
    }

    /**
     * Import data
     * By default, deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone.&lt;/b&gt;  Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes. After the delete, it then imports the tables, tags, and queries in the provided cb file into the workspace. &lt;br&gt;&lt;br&gt;This is an asynchronous operation. Returns a 201 when the file is correctly decoded and its tables, queries, and tags are saved. Files continue to import after this call completes.
     * @param file The file containing workspace information to import (optional)
     * @param wipe wipe (optional, default to true)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> importDataUsingPOSTWithHttpInfo(File file, Boolean wipe) throws ApiException {
        com.squareup.okhttp.Call call = importDataUsingPOSTCall(file, wipe, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Import data (asynchronously)
     * By default, deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone.&lt;/b&gt;  Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes. After the delete, it then imports the tables, tags, and queries in the provided cb file into the workspace. &lt;br&gt;&lt;br&gt;This is an asynchronous operation. Returns a 201 when the file is correctly decoded and its tables, queries, and tags are saved. Files continue to import after this call completes.
     * @param file The file containing workspace information to import (optional)
     * @param wipe wipe (optional, default to true)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call importDataUsingPOSTAsync(File file, Boolean wipe, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = importDataUsingPOSTCall(file, wipe, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for validateFilesUsingPOST */
    private com.squareup.okhttp.Call validateFilesUsingPOSTCall(StartValidateFilesDto validateFilesDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = validateFilesDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/validation/files".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Validate files
     * Validates files associated with the provided table ID. Validation repairs any files in an inconsistent state, and deletes those without enough state to recover. All files deleted or repaired are returned.
     * @param validateFilesDto The representation of the file to validate (optional)
     * @return BaseResponseOfValidateFilesDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfValidateFilesDto validateFilesUsingPOST(StartValidateFilesDto validateFilesDto) throws ApiException {
        ApiResponse<BaseResponseOfValidateFilesDto> resp = validateFilesUsingPOSTWithHttpInfo(validateFilesDto);
        return resp.getData();
    }

    /**
     * Validate files
     * Validates files associated with the provided table ID. Validation repairs any files in an inconsistent state, and deletes those without enough state to recover. All files deleted or repaired are returned.
     * @param validateFilesDto The representation of the file to validate (optional)
     * @return ApiResponse&lt;BaseResponseOfValidateFilesDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfValidateFilesDto> validateFilesUsingPOSTWithHttpInfo(StartValidateFilesDto validateFilesDto) throws ApiException {
        com.squareup.okhttp.Call call = validateFilesUsingPOSTCall(validateFilesDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfValidateFilesDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Validate files (asynchronously)
     * Validates files associated with the provided table ID. Validation repairs any files in an inconsistent state, and deletes those without enough state to recover. All files deleted or repaired are returned.
     * @param validateFilesDto The representation of the file to validate (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call validateFilesUsingPOSTAsync(StartValidateFilesDto validateFilesDto, final ApiCallback<BaseResponseOfValidateFilesDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = validateFilesUsingPOSTCall(validateFilesDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfValidateFilesDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for validateTablesUsingPOST */
    private com.squareup.okhttp.Call validateTablesUsingPOSTCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/admin/validation/tables".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Validate tables
     * Validates the tables in the workspace associated with the request. Validation returns an entity that indicates the tables deleted due to bad state, and those with enough state and repaired.
     * @return BaseResponseOfValidateTablesDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfValidateTablesDto validateTablesUsingPOST() throws ApiException {
        ApiResponse<BaseResponseOfValidateTablesDto> resp = validateTablesUsingPOSTWithHttpInfo();
        return resp.getData();
    }

    /**
     * Validate tables
     * Validates the tables in the workspace associated with the request. Validation returns an entity that indicates the tables deleted due to bad state, and those with enough state and repaired.
     * @return ApiResponse&lt;BaseResponseOfValidateTablesDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfValidateTablesDto> validateTablesUsingPOSTWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = validateTablesUsingPOSTCall(null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfValidateTablesDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Validate tables (asynchronously)
     * Validates the tables in the workspace associated with the request. Validation returns an entity that indicates the tables deleted due to bad state, and those with enough state and repaired.
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call validateTablesUsingPOSTAsync(final ApiCallback<BaseResponseOfValidateTablesDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = validateTablesUsingPOSTCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfValidateTablesDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
