/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.BaseResponseOfConnectionDto;
import io.swagger.client.model.BaseResponseOfRefreshBatchDto;
import io.swagger.client.model.BaseResponseOfConnectionRunDto;
import io.swagger.client.model.PagedResponseOfConnectionDto;
import io.swagger.client.model.RefreshConnectionDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ConnectionManagementApi {
    private ApiClient apiClient;

    public ConnectionManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ConnectionManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for getConnectionUsingGET */
    private com.squareup.okhttp.Call getConnectionUsingGETCall(String connectionId, String workspaceId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'connectionId' is set
        if (connectionId == null) {
            throw new ApiException("Missing the required parameter 'connectionId' when calling getConnectionUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/connections/{connectionId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "connectionId" + "\\}", apiClient.escapeString(connectionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (workspaceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "workspaceId", workspaceId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Get connection details
     * Returns details about a specific connection, based on its ID
     * @param connectionId The ID of the connection to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @return BaseResponseOfConnectionDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfConnectionDto getConnectionUsingGET(String connectionId, String workspaceId) throws ApiException {
        ApiResponse<BaseResponseOfConnectionDto> resp = getConnectionUsingGETWithHttpInfo(connectionId, workspaceId);
        return resp.getData();
    }

    /**
     * Get connection details
     * Returns details about a specific connection, based on its ID
     * @param connectionId The ID of the connection to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @return ApiResponse&lt;BaseResponseOfConnectionDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfConnectionDto> getConnectionUsingGETWithHttpInfo(String connectionId, String workspaceId) throws ApiException {
        com.squareup.okhttp.Call call = getConnectionUsingGETCall(connectionId, workspaceId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfConnectionDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get connection details (asynchronously)
     * Returns details about a specific connection, based on its ID
     * @param connectionId The ID of the connection to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getConnectionUsingGETAsync(String connectionId, String workspaceId, final ApiCallback<BaseResponseOfConnectionDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getConnectionUsingGETCall(connectionId, workspaceId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfConnectionDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getRefreshBatchStatusUsingGET */
    private com.squareup.okhttp.Call getRefreshBatchStatusUsingGETCall(String batchId, String workspaceId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'batchId' is set
        if (batchId == null) {
            throw new ApiException("Missing the required parameter 'batchId' when calling getRefreshBatchStatusUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/connections/batch/refresh/{batchId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "batchId" + "\\}", apiClient.escapeString(batchId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (workspaceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "workspaceId", workspaceId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Gets the status of a batch refresh
     * Returns details about a specific batch refresh, based on its ID.
     * @param batchId The ID of the batch to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @return BaseResponseOfRefreshBatchDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfRefreshBatchDto getRefreshBatchStatusUsingGET(String batchId, String workspaceId) throws ApiException {
        ApiResponse<BaseResponseOfRefreshBatchDto> resp = getRefreshBatchStatusUsingGETWithHttpInfo(batchId, workspaceId);
        return resp.getData();
    }

    /**
     * Gets the status of a batch refresh
     * Returns details about a specific batch refresh, based on its ID.
     * @param batchId The ID of the batch to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @return ApiResponse&lt;BaseResponseOfRefreshBatchDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfRefreshBatchDto> getRefreshBatchStatusUsingGETWithHttpInfo(String batchId, String workspaceId) throws ApiException {
        com.squareup.okhttp.Call call = getRefreshBatchStatusUsingGETCall(batchId, workspaceId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfRefreshBatchDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Gets the status of a batch refresh (asynchronously)
     * Returns details about a specific batch refresh, based on its ID.
     * @param batchId The ID of the batch to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getRefreshBatchStatusUsingGETAsync(String batchId, String workspaceId, final ApiCallback<BaseResponseOfRefreshBatchDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getRefreshBatchStatusUsingGETCall(batchId, workspaceId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfRefreshBatchDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getRefreshStatusUsingGET */
    private com.squareup.okhttp.Call getRefreshStatusUsingGETCall(String connectionId, String workspaceId, String jobId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'connectionId' is set
        if (connectionId == null) {
            throw new ApiException("Missing the required parameter 'connectionId' when calling getRefreshStatusUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/connections/{connectionId}/status".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "connectionId" + "\\}", apiClient.escapeString(connectionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (workspaceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "workspaceId", workspaceId));
        if (jobId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "jobId", jobId));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Get connection refresh status
     * Returns details about a specific connection refresh status, based on its ID. To retrieve details about a specific refresh, provide its &#39;jobId&#39;.
     * @param connectionId The ID of the connection to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @param jobId The ID of the job running for a connection (optional)
     * @return BaseResponseOfConnectionRunDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfConnectionRunDto getRefreshStatusUsingGET(String connectionId, String workspaceId, String jobId) throws ApiException {
        ApiResponse<BaseResponseOfConnectionRunDto> resp = getRefreshStatusUsingGETWithHttpInfo(connectionId, workspaceId, jobId);
        return resp.getData();
    }

    /**
     * Get connection refresh status
     * Returns details about a specific connection refresh status, based on its ID. To retrieve details about a specific refresh, provide its &#39;jobId&#39;.
     * @param connectionId The ID of the connection to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @param jobId The ID of the job running for a connection (optional)
     * @return ApiResponse&lt;BaseResponseOfConnectionRunDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfConnectionRunDto> getRefreshStatusUsingGETWithHttpInfo(String connectionId, String workspaceId, String jobId) throws ApiException {
        com.squareup.okhttp.Call call = getRefreshStatusUsingGETCall(connectionId, workspaceId, jobId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfConnectionRunDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get connection refresh status (asynchronously)
     * Returns details about a specific connection refresh status, based on its ID. To retrieve details about a specific refresh, provide its &#39;jobId&#39;.
     * @param connectionId The ID of the connection to return details about (required)
     * @param workspaceId workspaceId (optional)
     * @param jobId The ID of the job running for a connection (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getRefreshStatusUsingGETAsync(String connectionId, String workspaceId, String jobId, final ApiCallback<BaseResponseOfConnectionRunDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getRefreshStatusUsingGETCall(connectionId, workspaceId, jobId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfConnectionRunDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listConnectionsUsingGET */
    private com.squareup.okhttp.Call listConnectionsUsingGETCall(String sourceType, String destinationType, String sourceId, String destinationId, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/connections".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (sourceType != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sourceType", sourceType));
        if (destinationType != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "destinationType", destinationType));
        if (sourceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sourceId", sourceId));
        if (destinationId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "destinationId", destinationId));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * List connections
     * A pageable endpoint to list data connections between features of the Workiva platform
     * @param sourceType The type of file or item the connection pulls data from (optional)
     * @param destinationType The type of file or item the connection sends data to (optional)
     * @param sourceId The ID of the file or item the connection pulls data from (optional)
     * @param destinationId The ID of the file or item the connection sends data to (optional)
     * @param limit The number of connections to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfConnectionDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfConnectionDto listConnectionsUsingGET(String sourceType, String destinationType, String sourceId, String destinationId, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfConnectionDto> resp = listConnectionsUsingGETWithHttpInfo(sourceType, destinationType, sourceId, destinationId, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * List connections
     * A pageable endpoint to list data connections between features of the Workiva platform
     * @param sourceType The type of file or item the connection pulls data from (optional)
     * @param destinationType The type of file or item the connection sends data to (optional)
     * @param sourceId The ID of the file or item the connection pulls data from (optional)
     * @param destinationId The ID of the file or item the connection sends data to (optional)
     * @param limit The number of connections to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfConnectionDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfConnectionDto> listConnectionsUsingGETWithHttpInfo(String sourceType, String destinationType, String sourceId, String destinationId, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listConnectionsUsingGETCall(sourceType, destinationType, sourceId, destinationId, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfConnectionDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List connections (asynchronously)
     * A pageable endpoint to list data connections between features of the Workiva platform
     * @param sourceType The type of file or item the connection pulls data from (optional)
     * @param destinationType The type of file or item the connection sends data to (optional)
     * @param sourceId The ID of the file or item the connection pulls data from (optional)
     * @param destinationId The ID of the file or item the connection sends data to (optional)
     * @param limit The number of connections to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listConnectionsUsingGETAsync(String sourceType, String destinationType, String sourceId, String destinationId, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfConnectionDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listConnectionsUsingGETCall(sourceType, destinationType, sourceId, destinationId, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfConnectionDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for refreshBatchUsingPOST */
    private com.squareup.okhttp.Call refreshBatchUsingPOSTCall(List<RefreshConnectionDto> refreshConnectionDtos, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = refreshConnectionDtos;
        
        // verify the required parameter 'refreshConnectionDtos' is set
        if (refreshConnectionDtos == null) {
            throw new ApiException("Missing the required parameter 'refreshConnectionDtos' when calling refreshBatchUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/connections/batch/refresh".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Refresh batch of connections
     * Refreshes multiple connections at once, based on their IDs
     * @param refreshConnectionDtos refreshConnectionDtos (required)
     * @return BaseResponseOfRefreshBatchDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfRefreshBatchDto refreshBatchUsingPOST(List<RefreshConnectionDto> refreshConnectionDtos) throws ApiException {
        ApiResponse<BaseResponseOfRefreshBatchDto> resp = refreshBatchUsingPOSTWithHttpInfo(refreshConnectionDtos);
        return resp.getData();
    }

    /**
     * Refresh batch of connections
     * Refreshes multiple connections at once, based on their IDs
     * @param refreshConnectionDtos refreshConnectionDtos (required)
     * @return ApiResponse&lt;BaseResponseOfRefreshBatchDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfRefreshBatchDto> refreshBatchUsingPOSTWithHttpInfo(List<RefreshConnectionDto> refreshConnectionDtos) throws ApiException {
        com.squareup.okhttp.Call call = refreshBatchUsingPOSTCall(refreshConnectionDtos, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfRefreshBatchDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Refresh batch of connections (asynchronously)
     * Refreshes multiple connections at once, based on their IDs
     * @param refreshConnectionDtos refreshConnectionDtos (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call refreshBatchUsingPOSTAsync(List<RefreshConnectionDto> refreshConnectionDtos, final ApiCallback<BaseResponseOfRefreshBatchDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = refreshBatchUsingPOSTCall(refreshConnectionDtos, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfRefreshBatchDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for refreshConnectionUsingPOST */
    private com.squareup.okhttp.Call refreshConnectionUsingPOSTCall(String connectionId, RefreshConnectionDto refreshConnectionDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = refreshConnectionDto;
        
        // verify the required parameter 'connectionId' is set
        if (connectionId == null) {
            throw new ApiException("Missing the required parameter 'connectionId' when calling refreshConnectionUsingPOST(Async)");
        }
        
        // verify the required parameter 'refreshConnectionDto' is set
        if (refreshConnectionDto == null) {
            throw new ApiException("Missing the required parameter 'refreshConnectionDto' when calling refreshConnectionUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/connections/{connectionId}/refresh".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "connectionId" + "\\}", apiClient.escapeString(connectionId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Refresh connection
     * Refreshes a specific connection, based on its ID
     * @param connectionId The ID of the connection to refresh (required)
     * @param refreshConnectionDto refreshConnectionDto (required)
     * @return BaseResponseOfConnectionRunDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfConnectionRunDto refreshConnectionUsingPOST(String connectionId, RefreshConnectionDto refreshConnectionDto) throws ApiException {
        ApiResponse<BaseResponseOfConnectionRunDto> resp = refreshConnectionUsingPOSTWithHttpInfo(connectionId, refreshConnectionDto);
        return resp.getData();
    }

    /**
     * Refresh connection
     * Refreshes a specific connection, based on its ID
     * @param connectionId The ID of the connection to refresh (required)
     * @param refreshConnectionDto refreshConnectionDto (required)
     * @return ApiResponse&lt;BaseResponseOfConnectionRunDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfConnectionRunDto> refreshConnectionUsingPOSTWithHttpInfo(String connectionId, RefreshConnectionDto refreshConnectionDto) throws ApiException {
        com.squareup.okhttp.Call call = refreshConnectionUsingPOSTCall(connectionId, refreshConnectionDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfConnectionRunDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Refresh connection (asynchronously)
     * Refreshes a specific connection, based on its ID
     * @param connectionId The ID of the connection to refresh (required)
     * @param refreshConnectionDto refreshConnectionDto (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call refreshConnectionUsingPOSTAsync(String connectionId, RefreshConnectionDto refreshConnectionDto, final ApiCallback<BaseResponseOfConnectionRunDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = refreshConnectionUsingPOSTCall(connectionId, refreshConnectionDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfConnectionRunDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
