/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.FolderDto;
import io.swagger.client.model.BaseResponseOfFolderDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.PagedResponseOfFolderableDto;
import io.swagger.client.model.PagedResponseOfFolderDto;
import io.swagger.client.model.FolderableDto;
import io.swagger.client.model.BaseResponseOfCollectionOfFolderableDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FolderManagementApi {
    private ApiClient apiClient;

    public FolderManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public FolderManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for createFolderUsingPOST */
    private com.squareup.okhttp.Call createFolderUsingPOSTCall(FolderDto folderDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = folderDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/folder".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Create a new folder
     * Creates a folder using the provided information and returns the folder meta.
     * @param folderDto The representation of the folder to create (optional)
     * @return BaseResponseOfFolderDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFolderDto createFolderUsingPOST(FolderDto folderDto) throws ApiException {
        ApiResponse<BaseResponseOfFolderDto> resp = createFolderUsingPOSTWithHttpInfo(folderDto);
        return resp.getData();
    }

    /**
     * Create a new folder
     * Creates a folder using the provided information and returns the folder meta.
     * @param folderDto The representation of the folder to create (optional)
     * @return ApiResponse&lt;BaseResponseOfFolderDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFolderDto> createFolderUsingPOSTWithHttpInfo(FolderDto folderDto) throws ApiException {
        com.squareup.okhttp.Call call = createFolderUsingPOSTCall(folderDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFolderDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new folder (asynchronously)
     * Creates a folder using the provided information and returns the folder meta.
     * @param folderDto The representation of the folder to create (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createFolderUsingPOSTAsync(FolderDto folderDto, final ApiCallback<BaseResponseOfFolderDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createFolderUsingPOSTCall(folderDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFolderDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for deleteFolderUsingDELETE */
    private com.squareup.okhttp.Call deleteFolderUsingDELETECall(String folderId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'folderId' is set
        if (folderId == null) {
            throw new ApiException("Missing the required parameter 'folderId' when calling deleteFolderUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/folder/{folderId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "folderId" + "\\}", apiClient.escapeString(folderId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single folder
     * Deletes the folder with the provided ID.  If the folder is not found, this is a no-op. &lt;b&gt;All files and sub-folders are also recursively deleted.&lt;/b&gt;
     * @param folderId The unique identifier of the folder (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteFolderUsingDELETE(String folderId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteFolderUsingDELETEWithHttpInfo(folderId);
        return resp.getData();
    }

    /**
     * Delete a single folder
     * Deletes the folder with the provided ID.  If the folder is not found, this is a no-op. &lt;b&gt;All files and sub-folders are also recursively deleted.&lt;/b&gt;
     * @param folderId The unique identifier of the folder (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteFolderUsingDELETEWithHttpInfo(String folderId) throws ApiException {
        com.squareup.okhttp.Call call = deleteFolderUsingDELETECall(folderId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single folder (asynchronously)
     * Deletes the folder with the provided ID.  If the folder is not found, this is a no-op. &lt;b&gt;All files and sub-folders are also recursively deleted.&lt;/b&gt;
     * @param folderId The unique identifier of the folder (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteFolderUsingDELETEAsync(String folderId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteFolderUsingDELETECall(folderId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getFolderUsingGET */
    private com.squareup.okhttp.Call getFolderUsingGETCall(String folderId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'folderId' is set
        if (folderId == null) {
            throw new ApiException("Missing the required parameter 'folderId' when calling getFolderUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/folder/{folderId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "folderId" + "\\}", apiClient.escapeString(folderId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a single folder
     * Returns a folder with the provided ID, or a 404 if no matching folder is found.
     * @param folderId The unique identifier of the folder (required)
     * @return BaseResponseOfFolderDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFolderDto getFolderUsingGET(String folderId) throws ApiException {
        ApiResponse<BaseResponseOfFolderDto> resp = getFolderUsingGETWithHttpInfo(folderId);
        return resp.getData();
    }

    /**
     * Retrieve a single folder
     * Returns a folder with the provided ID, or a 404 if no matching folder is found.
     * @param folderId The unique identifier of the folder (required)
     * @return ApiResponse&lt;BaseResponseOfFolderDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFolderDto> getFolderUsingGETWithHttpInfo(String folderId) throws ApiException {
        com.squareup.okhttp.Call call = getFolderUsingGETCall(folderId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFolderDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a single folder (asynchronously)
     * Returns a folder with the provided ID, or a 404 if no matching folder is found.
     * @param folderId The unique identifier of the folder (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getFolderUsingGETAsync(String folderId, final ApiCallback<BaseResponseOfFolderDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getFolderUsingGETCall(folderId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFolderDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listChildrenUsingGET */
    private com.squareup.okhttp.Call listChildrenUsingGETCall(String folderId, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'folderId' is set
        if (folderId == null) {
            throw new ApiException("Missing the required parameter 'folderId' when calling listChildrenUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/folder/{folderId}/children".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "folderId" + "\\}", apiClient.escapeString(folderId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve list of folder contents
     * Returns a paged list of all children whose parent ID matches the provided folder ID.  If the folder ID in the path is the literal &#39;null&#39; value, returns a list of all entities with no parent.
     * @param folderId The unique identifier of the folder (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfFolderableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfFolderableDto listChildrenUsingGET(String folderId, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfFolderableDto> resp = listChildrenUsingGETWithHttpInfo(folderId, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve list of folder contents
     * Returns a paged list of all children whose parent ID matches the provided folder ID.  If the folder ID in the path is the literal &#39;null&#39; value, returns a list of all entities with no parent.
     * @param folderId The unique identifier of the folder (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfFolderableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfFolderableDto> listChildrenUsingGETWithHttpInfo(String folderId, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listChildrenUsingGETCall(folderId, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfFolderableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve list of folder contents (asynchronously)
     * Returns a paged list of all children whose parent ID matches the provided folder ID.  If the folder ID in the path is the literal &#39;null&#39; value, returns a list of all entities with no parent.
     * @param folderId The unique identifier of the folder (required)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listChildrenUsingGETAsync(String folderId, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfFolderableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listChildrenUsingGETCall(folderId, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfFolderableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listFoldersUsingGET */
    private com.squareup.okhttp.Call listFoldersUsingGETCall(Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/folder".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of folders
     * Returns a paged list of all folders associated with the workspace.
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfFolderDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfFolderDto listFoldersUsingGET(Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfFolderDto> resp = listFoldersUsingGETWithHttpInfo(limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of folders
     * Returns a paged list of all folders associated with the workspace.
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfFolderDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfFolderDto> listFoldersUsingGETWithHttpInfo(Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listFoldersUsingGETCall(limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfFolderDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of folders (asynchronously)
     * Returns a paged list of all folders associated with the workspace.
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listFoldersUsingGETAsync(Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfFolderDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listFoldersUsingGETCall(limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfFolderDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for searchUsingGET */
    private com.squareup.okhttp.Call searchUsingGETCall(String name, String description, List<Integer> type, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/entity".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "name", name));
        if (description != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "description", description));
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "type", type));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*_/_*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Search
     * Returns a list of all entities that match the provided criteria. Both name and description are fuzzy matches; they match _any_ entity that contains the provided string. The type is used to filter results based on the provided type of entity.  The consumer must have READ access on all returned entities.
     * @param name The name to use when fuzzy-matching entities (optional)
     * @param description The description to use when fuzzy-matching entities (optional)
     * @param type To limit the scope, the type of entity to return in the results (optional)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfFolderableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfFolderableDto searchUsingGET(String name, String description, List<Integer> type, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfFolderableDto> resp = searchUsingGETWithHttpInfo(name, description, type, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Search
     * Returns a list of all entities that match the provided criteria. Both name and description are fuzzy matches; they match _any_ entity that contains the provided string. The type is used to filter results based on the provided type of entity.  The consumer must have READ access on all returned entities.
     * @param name The name to use when fuzzy-matching entities (optional)
     * @param description The description to use when fuzzy-matching entities (optional)
     * @param type To limit the scope, the type of entity to return in the results (optional)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfFolderableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfFolderableDto> searchUsingGETWithHttpInfo(String name, String description, List<Integer> type, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = searchUsingGETCall(name, description, type, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfFolderableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Search (asynchronously)
     * Returns a list of all entities that match the provided criteria. Both name and description are fuzzy matches; they match _any_ entity that contains the provided string. The type is used to filter results based on the provided type of entity.  The consumer must have READ access on all returned entities.
     * @param name The name to use when fuzzy-matching entities (optional)
     * @param description The description to use when fuzzy-matching entities (optional)
     * @param type To limit the scope, the type of entity to return in the results (optional)
     * @param limit The number of folders to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call searchUsingGETAsync(String name, String description, List<Integer> type, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfFolderableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = searchUsingGETCall(name, description, type, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfFolderableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for setChildrenUsingPOST */
    private com.squareup.okhttp.Call setChildrenUsingPOSTCall(String folderId, List<FolderableDto> children, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = children;
        
        // verify the required parameter 'folderId' is set
        if (folderId == null) {
            throw new ApiException("Missing the required parameter 'folderId' when calling setChildrenUsingPOST(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/folder/{folderId}/children".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "folderId" + "\\}", apiClient.escapeString(folderId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Move content into a folder
     * Sets the children of a folder using the entities&#39; types and IDs provided in the body. If the entities previously resided under a folder, including the root, they move to the folder with the provided ID. If the provided ID is &#39;null&#39;, the entities move to the root folder.
     * @param folderId The unique identifier of the folder (required)
     * @param children The representation of the entities to drop into the folder (optional)
     * @return BaseResponseOfCollectionOfFolderableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfCollectionOfFolderableDto setChildrenUsingPOST(String folderId, List<FolderableDto> children) throws ApiException {
        ApiResponse<BaseResponseOfCollectionOfFolderableDto> resp = setChildrenUsingPOSTWithHttpInfo(folderId, children);
        return resp.getData();
    }

    /**
     * Move content into a folder
     * Sets the children of a folder using the entities&#39; types and IDs provided in the body. If the entities previously resided under a folder, including the root, they move to the folder with the provided ID. If the provided ID is &#39;null&#39;, the entities move to the root folder.
     * @param folderId The unique identifier of the folder (required)
     * @param children The representation of the entities to drop into the folder (optional)
     * @return ApiResponse&lt;BaseResponseOfCollectionOfFolderableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfCollectionOfFolderableDto> setChildrenUsingPOSTWithHttpInfo(String folderId, List<FolderableDto> children) throws ApiException {
        com.squareup.okhttp.Call call = setChildrenUsingPOSTCall(folderId, children, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfCollectionOfFolderableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Move content into a folder (asynchronously)
     * Sets the children of a folder using the entities&#39; types and IDs provided in the body. If the entities previously resided under a folder, including the root, they move to the folder with the provided ID. If the provided ID is &#39;null&#39;, the entities move to the root folder.
     * @param folderId The unique identifier of the folder (required)
     * @param children The representation of the entities to drop into the folder (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call setChildrenUsingPOSTAsync(String folderId, List<FolderableDto> children, final ApiCallback<BaseResponseOfCollectionOfFolderableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = setChildrenUsingPOSTCall(folderId, children, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfCollectionOfFolderableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for updateFolderUsingPUT */
    private com.squareup.okhttp.Call updateFolderUsingPUTCall(String folderId, FolderDto folderDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = folderDto;
        
        // verify the required parameter 'folderId' is set
        if (folderId == null) {
            throw new ApiException("Missing the required parameter 'folderId' when calling updateFolderUsingPUT(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/folder/{folderId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "folderId" + "\\}", apiClient.escapeString(folderId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Update a single folder
     * Updates the folder that matches the provided ID with the details provided in the body.
     * @param folderId The unique identifier of the folder (required)
     * @param folderDto The representation of the folder to update (optional)
     * @return BaseResponseOfFolderDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfFolderDto updateFolderUsingPUT(String folderId, FolderDto folderDto) throws ApiException {
        ApiResponse<BaseResponseOfFolderDto> resp = updateFolderUsingPUTWithHttpInfo(folderId, folderDto);
        return resp.getData();
    }

    /**
     * Update a single folder
     * Updates the folder that matches the provided ID with the details provided in the body.
     * @param folderId The unique identifier of the folder (required)
     * @param folderDto The representation of the folder to update (optional)
     * @return ApiResponse&lt;BaseResponseOfFolderDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfFolderDto> updateFolderUsingPUTWithHttpInfo(String folderId, FolderDto folderDto) throws ApiException {
        com.squareup.okhttp.Call call = updateFolderUsingPUTCall(folderId, folderDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfFolderDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update a single folder (asynchronously)
     * Updates the folder that matches the provided ID with the details provided in the body.
     * @param folderId The unique identifier of the folder (required)
     * @param folderDto The representation of the folder to update (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateFolderUsingPUTAsync(String folderId, FolderDto folderDto, final ApiCallback<BaseResponseOfFolderDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateFolderUsingPUTCall(folderId, folderDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfFolderDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
