/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;

import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.SharedTableDto;
import io.swagger.client.model.BaseResponseOfSharedTableDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.PagedResponseOfSharedTableDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SharedTableManagementApi {
    private ApiClient apiClient;

    public SharedTableManagementApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SharedTableManagementApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for createSharedTableUsingPOST */
    private com.squareup.okhttp.Call createSharedTableUsingPOSTCall(SharedTableDto sharedTableDto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = sharedTableDto;
        

        // create path and map variables
        String localVarPath = "/api/v1/sharedtable".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Create a new shared table
     * Creates a shared table instance between the workspace of the request and the workspace provided in the body.
     * @param sharedTableDto The representation of the shared table to create (optional)
     * @return BaseResponseOfSharedTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfSharedTableDto createSharedTableUsingPOST(SharedTableDto sharedTableDto) throws ApiException {
        ApiResponse<BaseResponseOfSharedTableDto> resp = createSharedTableUsingPOSTWithHttpInfo(sharedTableDto);
        return resp.getData();
    }

    /**
     * Create a new shared table
     * Creates a shared table instance between the workspace of the request and the workspace provided in the body.
     * @param sharedTableDto The representation of the shared table to create (optional)
     * @return ApiResponse&lt;BaseResponseOfSharedTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfSharedTableDto> createSharedTableUsingPOSTWithHttpInfo(SharedTableDto sharedTableDto) throws ApiException {
        com.squareup.okhttp.Call call = createSharedTableUsingPOSTCall(sharedTableDto, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfSharedTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new shared table (asynchronously)
     * Creates a shared table instance between the workspace of the request and the workspace provided in the body.
     * @param sharedTableDto The representation of the shared table to create (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createSharedTableUsingPOSTAsync(SharedTableDto sharedTableDto, final ApiCallback<BaseResponseOfSharedTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createSharedTableUsingPOSTCall(sharedTableDto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfSharedTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for deleteSharedTableUsingDELETE */
    private com.squareup.okhttp.Call deleteSharedTableUsingDELETECall(String sharedTableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'sharedTableId' is set
        if (sharedTableId == null) {
            throw new ApiException("Missing the required parameter 'sharedTableId' when calling deleteSharedTableUsingDELETE(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/sharedtable/{sharedTableId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "sharedTableId" + "\\}", apiClient.escapeString(sharedTableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Delete a single shared table
     * Deletes the linkages between the source and destination of a shared table that matches the provided ID; the actual table itself is left intact. If no such shared table exists, this is a no-op.
     * @param sharedTableId The unique identifier of the shared table (required)
     * @return BaseResponseOfstring
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfstring deleteSharedTableUsingDELETE(String sharedTableId) throws ApiException {
        ApiResponse<BaseResponseOfstring> resp = deleteSharedTableUsingDELETEWithHttpInfo(sharedTableId);
        return resp.getData();
    }

    /**
     * Delete a single shared table
     * Deletes the linkages between the source and destination of a shared table that matches the provided ID; the actual table itself is left intact. If no such shared table exists, this is a no-op.
     * @param sharedTableId The unique identifier of the shared table (required)
     * @return ApiResponse&lt;BaseResponseOfstring&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfstring> deleteSharedTableUsingDELETEWithHttpInfo(String sharedTableId) throws ApiException {
        com.squareup.okhttp.Call call = deleteSharedTableUsingDELETECall(sharedTableId, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete a single shared table (asynchronously)
     * Deletes the linkages between the source and destination of a shared table that matches the provided ID; the actual table itself is left intact. If no such shared table exists, this is a no-op.
     * @param sharedTableId The unique identifier of the shared table (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteSharedTableUsingDELETEAsync(String sharedTableId, final ApiCallback<BaseResponseOfstring> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteSharedTableUsingDELETECall(sharedTableId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfstring>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getSharedTableUsingGET */
    private com.squareup.okhttp.Call getSharedTableUsingGETCall(String sharedTableId, Boolean sharedWithMe, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // verify the required parameter 'sharedTableId' is set
        if (sharedTableId == null) {
            throw new ApiException("Missing the required parameter 'sharedTableId' when calling getSharedTableUsingGET(Async)");
        }
        

        // create path and map variables
        String localVarPath = "/api/v1/sharedtable/{sharedTableId}".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "sharedTableId" + "\\}", apiClient.escapeString(sharedTableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (sharedWithMe != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sharedWithMe", sharedWithMe));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a single shared table
     * Returns a shared table that matches the provided ID, or a 404 if no matching shared table is found.
     * @param sharedTableId The unique identifier of the shared table (required)
     * @param sharedWithMe If true, returns a shared table with the provided ID that has been shared _to_—rather than from—the workspace of the request. (optional)
     * @return BaseResponseOfSharedTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BaseResponseOfSharedTableDto getSharedTableUsingGET(String sharedTableId, Boolean sharedWithMe) throws ApiException {
        ApiResponse<BaseResponseOfSharedTableDto> resp = getSharedTableUsingGETWithHttpInfo(sharedTableId, sharedWithMe);
        return resp.getData();
    }

    /**
     * Retrieve a single shared table
     * Returns a shared table that matches the provided ID, or a 404 if no matching shared table is found.
     * @param sharedTableId The unique identifier of the shared table (required)
     * @param sharedWithMe If true, returns a shared table with the provided ID that has been shared _to_—rather than from—the workspace of the request. (optional)
     * @return ApiResponse&lt;BaseResponseOfSharedTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BaseResponseOfSharedTableDto> getSharedTableUsingGETWithHttpInfo(String sharedTableId, Boolean sharedWithMe) throws ApiException {
        com.squareup.okhttp.Call call = getSharedTableUsingGETCall(sharedTableId, sharedWithMe, null, null);
        Type localVarReturnType = new TypeToken<BaseResponseOfSharedTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a single shared table (asynchronously)
     * Returns a shared table that matches the provided ID, or a 404 if no matching shared table is found.
     * @param sharedTableId The unique identifier of the shared table (required)
     * @param sharedWithMe If true, returns a shared table with the provided ID that has been shared _to_—rather than from—the workspace of the request. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getSharedTableUsingGETAsync(String sharedTableId, Boolean sharedWithMe, final ApiCallback<BaseResponseOfSharedTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getSharedTableUsingGETCall(sharedTableId, sharedWithMe, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BaseResponseOfSharedTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for listSharedTablesUsingGET */
    private com.squareup.okhttp.Call listSharedTablesUsingGETCall(String tableId, Boolean sharedWithMe, Integer limit, String cursor, Long offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        

        // create path and map variables
        String localVarPath = "/api/v1/sharedtable".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (tableId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "tableId", tableId));
        if (sharedWithMe != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sharedWithMe", sharedWithMe));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (cursor != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cursor", cursor));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "oauth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    /**
     * Retrieve a list of shared tables
     * Returns a list of shared tables associated with the workspace of the request.
     * @param tableId The unique table identifier associated with the shared table (optional)
     * @param sharedWithMe If true, returns a list of tables that have been shared _to_ it rather than from it. The entities contain both the shared table entity _and_ the table being shared. If true, &#x60;tableId&#x60; is ignored. (optional)
     * @param limit The number of shared files to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return PagedResponseOfSharedTableDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PagedResponseOfSharedTableDto listSharedTablesUsingGET(String tableId, Boolean sharedWithMe, Integer limit, String cursor, Long offset) throws ApiException {
        ApiResponse<PagedResponseOfSharedTableDto> resp = listSharedTablesUsingGETWithHttpInfo(tableId, sharedWithMe, limit, cursor, offset);
        return resp.getData();
    }

    /**
     * Retrieve a list of shared tables
     * Returns a list of shared tables associated with the workspace of the request.
     * @param tableId The unique table identifier associated with the shared table (optional)
     * @param sharedWithMe If true, returns a list of tables that have been shared _to_ it rather than from it. The entities contain both the shared table entity _and_ the table being shared. If true, &#x60;tableId&#x60; is ignored. (optional)
     * @param limit The number of shared files to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @return ApiResponse&lt;PagedResponseOfSharedTableDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PagedResponseOfSharedTableDto> listSharedTablesUsingGETWithHttpInfo(String tableId, Boolean sharedWithMe, Integer limit, String cursor, Long offset) throws ApiException {
        com.squareup.okhttp.Call call = listSharedTablesUsingGETCall(tableId, sharedWithMe, limit, cursor, offset, null, null);
        Type localVarReturnType = new TypeToken<PagedResponseOfSharedTableDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Retrieve a list of shared tables (asynchronously)
     * Returns a list of shared tables associated with the workspace of the request.
     * @param tableId The unique table identifier associated with the shared table (optional)
     * @param sharedWithMe If true, returns a list of tables that have been shared _to_ it rather than from it. The entities contain both the shared table entity _and_ the table being shared. If true, &#x60;tableId&#x60; is ignored. (optional)
     * @param limit The number of shared files to return, from 1 to 1000; by default, 1000 (optional)
     * @param cursor A paging cursor; if included, &#x60;limit&#x60; is ignored (optional)
     * @param offset The item to start with on the page, greater than or equal to 0; by default, 0 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call listSharedTablesUsingGETAsync(String tableId, Boolean sharedWithMe, Integer limit, String cursor, Long offset, final ApiCallback<PagedResponseOfSharedTableDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = listSharedTablesUsingGETCall(tableId, sharedWithMe, limit, cursor, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PagedResponseOfSharedTableDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
