/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.joda.time.DateTime;


/**
 * FileMetaDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-08-12T17:57:42.234Z")
public class FileMetaDto   {
  @SerializedName("columnMappings")
  private Map<String, String> columnMappings = new HashMap<String, String>();

  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("delimiter")
  private String delimiter = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("key")
  private String key = null;

  @SerializedName("metadata")
  private Map<String, Map<String, Object>> metadata = new HashMap<String, Map<String, Object>>();

  @SerializedName("name")
  private String name = null;

  @SerializedName("numErrors")
  private Long numErrors = null;

  @SerializedName("numRecords")
  private Long numRecords = null;

  @SerializedName("originalFileSize")
  private Long originalFileSize = null;

  @SerializedName("source")
  private String source = null;

  /**
   * The files's current status
   */
  public enum StatusEnum {
    @SerializedName("STAGING")
    STAGING("STAGING"),
    
    @SerializedName("STAGED")
    STAGED("STAGED"),
    
    @SerializedName("IMPORTING")
    IMPORTING("IMPORTING"),
    
    @SerializedName("IMPORTED")
    IMPORTED("IMPORTED"),
    
    @SerializedName("ERROR")
    ERROR("ERROR");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("status")
  private StatusEnum status = null;

  @SerializedName("tableId")
  private String tableId = null;

  @SerializedName("tags")
  private Map<String, String> tags = new HashMap<String, String>();

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

  public FileMetaDto columnMappings(Map<String, String> columnMappings) {
    this.columnMappings = columnMappings;
    return this;
  }

  public FileMetaDto putColumnMappingsItem(String key, String columnMappingsItem) {
    this.columnMappings.put(key, columnMappingsItem);
    return this;
  }

   /**
   * Maps the columns in the physical file (CSV or JSON) to the columns in fact table = {\"physical_col1\":\"table_col1\", \"physical_col2\":\"table_col2\"}
   * @return columnMappings
  **/
  @ApiModelProperty(example = "null", value = "Maps the columns in the physical file (CSV or JSON) to the columns in fact table = {\"physical_col1\":\"table_col1\", \"physical_col2\":\"table_col2\"}")
  public Map<String, String> getColumnMappings() {
    return columnMappings;
  }

  public void setColumnMappings(Map<String, String> columnMappings) {
    this.columnMappings = columnMappings;
  }

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The character to use as a delimiter within the file to separate one field from another.  The default is comma
   * @return delimiter
  **/
  @ApiModelProperty(example = "null", value = "The character to use as a delimiter within the file to separate one field from another.  The default is comma")
  public String getDelimiter() {
    return delimiter;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

   /**
   * The key is here for backwards compatibility only and will always be an empty string.
   * @return key
  **/
  @ApiModelProperty(example = "null", value = "The key is here for backwards compatibility only and will always be an empty string.")
  public String getKey() {
    return key;
  }

  public FileMetaDto metadata(Map<String, Map<String, Object>> metadata) {
    this.metadata = metadata;
    return this;
  }

  public FileMetaDto putMetadataItem(String key, Map<String, Object> metadataItem) {
    this.metadata.put(key, metadataItem);
    return this;
  }

   /**
   * The file's meta data
   * @return metadata
  **/
  @ApiModelProperty(example = "null", value = "The file's meta data")
  public Map<String, Map<String, Object>> getMetadata() {
    return metadata;
  }

  public void setMetadata(Map<String, Map<String, Object>> metadata) {
    this.metadata = metadata;
  }

   /**
   * The name of the file
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the file")
  public String getName() {
    return name;
  }

   /**
   * Number of errors found in the file
   * @return numErrors
  **/
  @ApiModelProperty(example = "null", value = "Number of errors found in the file")
  public Long getNumErrors() {
    return numErrors;
  }

   /**
   * Number of records imported from this file.  This will only be non-zero if the file is in the IMPORTED status.
   * @return numRecords
  **/
  @ApiModelProperty(example = "null", value = "Number of records imported from this file.  This will only be non-zero if the file is in the IMPORTED status.")
  public Long getNumRecords() {
    return numRecords;
  }

   /**
   * Size of the original file that was uploaded.
   * @return originalFileSize
  **/
  @ApiModelProperty(example = "null", value = "Size of the original file that was uploaded.")
  public Long getOriginalFileSize() {
    return originalFileSize;
  }

   /**
   * URI that describes the source location of this file if imported from another system. For instance, this will have a spreadsheet URL if this file was imported from spreadsheets. This will be null if the file was uploaded using the data prep API.
   * @return source
  **/
  @ApiModelProperty(example = "null", value = "URI that describes the source location of this file if imported from another system. For instance, this will have a spreadsheet URL if this file was imported from spreadsheets. This will be null if the file was uploaded using the data prep API.")
  public String getSource() {
    return source;
  }

   /**
   * The files's current status
   * @return status
  **/
  @ApiModelProperty(example = "null", value = "The files's current status")
  public StatusEnum getStatus() {
    return status;
  }

   /**
   * The unique identifier for the table
   * @return tableId
  **/
  @ApiModelProperty(example = "null", value = "The unique identifier for the table")
  public String getTableId() {
    return tableId;
  }

  public FileMetaDto tags(Map<String, String> tags) {
    this.tags = tags;
    return this;
  }

  public FileMetaDto putTagsItem(String key, String tagsItem) {
    this.tags.put(key, tagsItem);
    return this;
  }

   /**
   * The tags associated with the file
   * @return tags
  **/
  @ApiModelProperty(example = "null", value = "The tags associated with the file")
  public Map<String, String> getTags() {
    return tags;
  }

  public void setTags(Map<String, String> tags) {
    this.tags = tags;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FileMetaDto fileMetaDto = (FileMetaDto) o;
    return Objects.equals(this.columnMappings, fileMetaDto.columnMappings) &&
        Objects.equals(this.created, fileMetaDto.created) &&
        Objects.equals(this.delimiter, fileMetaDto.delimiter) &&
        Objects.equals(this.id, fileMetaDto.id) &&
        Objects.equals(this.key, fileMetaDto.key) &&
        Objects.equals(this.metadata, fileMetaDto.metadata) &&
        Objects.equals(this.name, fileMetaDto.name) &&
        Objects.equals(this.numErrors, fileMetaDto.numErrors) &&
        Objects.equals(this.numRecords, fileMetaDto.numRecords) &&
        Objects.equals(this.originalFileSize, fileMetaDto.originalFileSize) &&
        Objects.equals(this.source, fileMetaDto.source) &&
        Objects.equals(this.status, fileMetaDto.status) &&
        Objects.equals(this.tableId, fileMetaDto.tableId) &&
        Objects.equals(this.tags, fileMetaDto.tags) &&
        Objects.equals(this.updated, fileMetaDto.updated) &&
        Objects.equals(this.userId, fileMetaDto.userId) &&
        Objects.equals(this.version, fileMetaDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(columnMappings, created, delimiter, id, key, metadata, name, numErrors, numRecords, originalFileSize, source, status, tableId, tags, updated, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FileMetaDto {\n");
    
    sb.append("    columnMappings: ").append(toIndentedString(columnMappings)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    delimiter: ").append(toIndentedString(delimiter)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    key: ").append(toIndentedString(key)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    numErrors: ").append(toIndentedString(numErrors)).append("\n");
    sb.append("    numRecords: ").append(toIndentedString(numRecords)).append("\n");
    sb.append("    originalFileSize: ").append(toIndentedString(originalFileSize)).append("\n");
    sb.append("    source: ").append(toIndentedString(source)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    tableId: ").append(toIndentedString(tableId)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

