/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import org.joda.time.DateTime;


/**
 * GlobalParameterDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-08-12T17:57:42.234Z")
public class GlobalParameterDto   {
  @SerializedName("choices")
  private List<Object> choices = new ArrayList<Object>();

  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("databaseId")
  private String databaseId = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("label")
  private String label = null;

  /**
   * The mode of the parameter
   */
  public enum ModeEnum {
    @SerializedName("scalar")
    SCALAR("scalar"),
    
    @SerializedName("singleSelect")
    SINGLESELECT("singleSelect"),
    
    @SerializedName("multiSelect")
    MULTISELECT("multiSelect");

    private String value;

    ModeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("mode")
  private ModeEnum mode = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("overridable")
  private Boolean overridable = null;

  @SerializedName("selectListId")
  private String selectListId = null;

  /**
   * The type of the parameter
   */
  public enum TypeEnum {
    @SerializedName("string")
    STRING("string"),
    
    @SerializedName("bytes")
    BYTES("bytes"),
    
    @SerializedName("integer")
    INTEGER("integer"),
    
    @SerializedName("float")
    FLOAT("float"),
    
    @SerializedName("boolean")
    BOOLEAN("boolean"),
    
    @SerializedName("timestamp")
    TIMESTAMP("timestamp"),
    
    @SerializedName("date")
    DATE("date"),
    
    @SerializedName("time")
    TIME("time"),
    
    @SerializedName("datetime")
    DATETIME("datetime"),
    
    @SerializedName("global_parameter")
    GLOBAL_PARAMETER("global_parameter"),
    
    @SerializedName("nested_query_parameter")
    NESTED_QUERY_PARAMETER("nested_query_parameter");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("value")
  private Object value = null;

  @SerializedName("version")
  private Long version = null;

  public GlobalParameterDto choices(List<Object> choices) {
    this.choices = choices;
    return this;
  }

  public GlobalParameterDto addChoicesItem(Object choicesItem) {
    this.choices.add(choicesItem);
    return this;
  }

   /**
   * If the parameter is of type select, this is a list of possible choices. This is read only and is for listing and viewing reports to help the user.
   * @return choices
  **/
  @ApiModelProperty(example = "null", value = "If the parameter is of type select, this is a list of possible choices. This is read only and is for listing and viewing reports to help the user.")
  public List<Object> getChoices() {
    return choices;
  }

  public void setChoices(List<Object> choices) {
    this.choices = choices;
  }

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The unique identifier of the database where this parameter can be used to filter query results
   * @return databaseId
  **/
  @ApiModelProperty(example = "null", value = "The unique identifier of the database where this parameter can be used to filter query results")
  public String getDatabaseId() {
    return databaseId;
  }

  public GlobalParameterDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The description of the parameter
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "The description of the parameter")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

  public GlobalParameterDto label(String label) {
    this.label = label;
    return this;
  }

   /**
   * The label for the query parameter
   * @return label
  **/
  @ApiModelProperty(example = "null", value = "The label for the query parameter")
  public String getLabel() {
    return label;
  }

  public void setLabel(String label) {
    this.label = label;
  }

  public GlobalParameterDto mode(ModeEnum mode) {
    this.mode = mode;
    return this;
  }

   /**
   * The mode of the parameter
   * @return mode
  **/
  @ApiModelProperty(example = "null", value = "The mode of the parameter")
  public ModeEnum getMode() {
    return mode;
  }

  public void setMode(ModeEnum mode) {
    this.mode = mode;
  }

  public GlobalParameterDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the parameter
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the parameter")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public GlobalParameterDto overridable(Boolean overridable) {
    this.overridable = overridable;
    return this;
  }

   /**
   * Denotes if this parameter can be overridden later in the process, either when the query is created or executed.  The default is true; it can be overridden.
   * @return overridable
  **/
  @ApiModelProperty(example = "false", value = "Denotes if this parameter can be overridden later in the process, either when the query is created or executed.  The default is true; it can be overridden.")
  public Boolean getOverridable() {
    return overridable;
  }

  public void setOverridable(Boolean overridable) {
    this.overridable = overridable;
  }

  public GlobalParameterDto selectListId(String selectListId) {
    this.selectListId = selectListId;
    return this;
  }

   /**
   * If mode is select, this must be populated and is a reference to a select list from which choices will be derived.
   * @return selectListId
  **/
  @ApiModelProperty(example = "null", value = "If mode is select, this must be populated and is a reference to a select list from which choices will be derived.")
  public String getSelectListId() {
    return selectListId;
  }

  public void setSelectListId(String selectListId) {
    this.selectListId = selectListId;
  }

  public GlobalParameterDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * The type of the parameter
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "The type of the parameter")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

  public GlobalParameterDto value(Object value) {
    this.value = value;
    return this;
  }

   /**
   * The default value of the parameter
   * @return value
  **/
  @ApiModelProperty(example = "null", value = "The default value of the parameter")
  public Object getValue() {
    return value;
  }

  public void setValue(Object value) {
    this.value = value;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GlobalParameterDto globalParameterDto = (GlobalParameterDto) o;
    return Objects.equals(this.choices, globalParameterDto.choices) &&
        Objects.equals(this.created, globalParameterDto.created) &&
        Objects.equals(this.databaseId, globalParameterDto.databaseId) &&
        Objects.equals(this.description, globalParameterDto.description) &&
        Objects.equals(this.id, globalParameterDto.id) &&
        Objects.equals(this.label, globalParameterDto.label) &&
        Objects.equals(this.mode, globalParameterDto.mode) &&
        Objects.equals(this.name, globalParameterDto.name) &&
        Objects.equals(this.overridable, globalParameterDto.overridable) &&
        Objects.equals(this.selectListId, globalParameterDto.selectListId) &&
        Objects.equals(this.type, globalParameterDto.type) &&
        Objects.equals(this.updated, globalParameterDto.updated) &&
        Objects.equals(this.userId, globalParameterDto.userId) &&
        Objects.equals(this.value, globalParameterDto.value) &&
        Objects.equals(this.version, globalParameterDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(choices, created, databaseId, description, id, label, mode, name, overridable, selectListId, type, updated, userId, value, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GlobalParameterDto {\n");
    
    sb.append("    choices: ").append(toIndentedString(choices)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    databaseId: ").append(toIndentedString(databaseId)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    label: ").append(toIndentedString(label)).append("\n");
    sb.append("    mode: ").append(toIndentedString(mode)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    overridable: ").append(toIndentedString(overridable)).append("\n");
    sb.append("    selectListId: ").append(toIndentedString(selectListId)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

