/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * ImportInfoDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-08-12T17:57:42.234Z")
public class ImportInfoDto   {
  @SerializedName("numFiles")
  private Long numFiles = null;

  @SerializedName("numRecords")
  private Long numRecords = null;

  @SerializedName("tableId")
  private String tableId = null;

  public ImportInfoDto numFiles(Long numFiles) {
    this.numFiles = numFiles;
    return this;
  }

   /**
   * The total number of individual files imported to the table.
   * @return numFiles
  **/
  @ApiModelProperty(example = "null", value = "The total number of individual files imported to the table.")
  public Long getNumFiles() {
    return numFiles;
  }

  public void setNumFiles(Long numFiles) {
    this.numFiles = numFiles;
  }

  public ImportInfoDto numRecords(Long numRecords) {
    this.numRecords = numRecords;
    return this;
  }

   /**
   * The total number of records/rows of data imported to the table.
   * @return numRecords
  **/
  @ApiModelProperty(example = "null", value = "The total number of records/rows of data imported to the table.")
  public Long getNumRecords() {
    return numRecords;
  }

  public void setNumRecords(Long numRecords) {
    this.numRecords = numRecords;
  }

  public ImportInfoDto tableId(String tableId) {
    this.tableId = tableId;
    return this;
  }

   /**
   * The id for the table that the import info applies to.
   * @return tableId
  **/
  @ApiModelProperty(example = "null", value = "The id for the table that the import info applies to.")
  public String getTableId() {
    return tableId;
  }

  public void setTableId(String tableId) {
    this.tableId = tableId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImportInfoDto importInfoDto = (ImportInfoDto) o;
    return Objects.equals(this.numFiles, importInfoDto.numFiles) &&
        Objects.equals(this.numRecords, importInfoDto.numRecords) &&
        Objects.equals(this.tableId, importInfoDto.tableId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(numFiles, numRecords, tableId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImportInfoDto {\n");
    
    sb.append("    numFiles: ").append(toIndentedString(numFiles)).append("\n");
    sb.append("    numRecords: ").append(toIndentedString(numRecords)).append("\n");
    sb.append("    tableId: ").append(toIndentedString(tableId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

