/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * The query text associated with any persisted query contains references to tables upon which that query relies. This model represents those dependencies. Every dependency contains a database and table identifier as in a traditional SQL database.
 */
@ApiModel(description = "The query text associated with any persisted query contains references to tables upon which that query relies. This model represents those dependencies. Every dependency contains a database and table identifier as in a traditional SQL database.")
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-08-12T17:57:42.234Z")
public class QueryDependencyDto   {
  @SerializedName("databaseId")
  private String databaseId = null;

  /**
   * The name of the system holding this reference.
   */
  public enum SystemEnum {
    @SerializedName("prep")
    PREP("prep"),
    
    @SerializedName("spreadsheets")
    SPREADSHEETS("spreadsheets"),
    
    @SerializedName("queries")
    QUERIES("queries"),
    
    @SerializedName("program")
    PROGRAM("program"),
    
    @SerializedName("com")
    COM("com"),
    
    @SerializedName("iam")
    IAM("iam"),
    
    @SerializedName("graph")
    GRAPH("graph"),
    
    @SerializedName("explorer")
    EXPLORER("explorer");

    private String value;

    SystemEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("system")
  private SystemEnum system = null;

  @SerializedName("tableId")
  private String tableId = null;

   /**
   * The database in which this dependency exists.
   * @return databaseId
  **/
  @ApiModelProperty(example = "null", value = "The database in which this dependency exists.")
  public String getDatabaseId() {
    return databaseId;
  }

   /**
   * The name of the system holding this reference.
   * @return system
  **/
  @ApiModelProperty(example = "null", value = "The name of the system holding this reference.")
  public SystemEnum getSystem() {
    return system;
  }

   /**
   * The id of the table this dependency represents.
   * @return tableId
  **/
  @ApiModelProperty(example = "null", value = "The id of the table this dependency represents.")
  public String getTableId() {
    return tableId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryDependencyDto queryDependencyDto = (QueryDependencyDto) o;
    return Objects.equals(this.databaseId, queryDependencyDto.databaseId) &&
        Objects.equals(this.system, queryDependencyDto.system) &&
        Objects.equals(this.tableId, queryDependencyDto.tableId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(databaseId, system, tableId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryDependencyDto {\n");
    
    sb.append("    databaseId: ").append(toIndentedString(databaseId)).append("\n");
    sb.append("    system: ").append(toIndentedString(system)).append("\n");
    sb.append("    tableId: ").append(toIndentedString(tableId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

