/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.PivotDefinitionDto;
import io.swagger.client.model.QueryDependencyDto;
import io.swagger.client.model.QueryParameterDto;
import java.util.ArrayList;
import java.util.List;
import org.joda.time.DateTime;


/**
 * QueryDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-08-12T17:57:42.234Z")
public class QueryDto   {
  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("definition")
  private PivotDefinitionDto definition = null;

  @SerializedName("dependencies")
  private List<QueryDependencyDto> dependencies = new ArrayList<QueryDependencyDto>();

  @SerializedName("description")
  private String description = null;

  @SerializedName("historyRevision")
  private Long historyRevision = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("lastRun")
  private DateTime lastRun = null;

  @SerializedName("lastRunBy")
  private String lastRunBy = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("parameters")
  private List<QueryParameterDto> parameters = new ArrayList<QueryParameterDto>();

  @SerializedName("parentId")
  private String parentId = null;

  @SerializedName("primaryQueryResultId")
  private String primaryQueryResultId = null;

  @SerializedName("queryText")
  private String queryText = null;

  @SerializedName("temporary")
  private Boolean temporary = null;

  @SerializedName("type")
  private String type = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

  public QueryDto definition(PivotDefinitionDto definition) {
    this.definition = definition;
    return this;
  }

   /**
   * The pivot view's definition
   * @return definition
  **/
  @ApiModelProperty(example = "null", value = "The pivot view's definition")
  public PivotDefinitionDto getDefinition() {
    return definition;
  }

  public void setDefinition(PivotDefinitionDto definition) {
    this.definition = definition;
  }

  public QueryDto dependencies(List<QueryDependencyDto> dependencies) {
    this.dependencies = dependencies;
    return this;
  }

  public QueryDto addDependenciesItem(QueryDependencyDto dependenciesItem) {
    this.dependencies.add(dependenciesItem);
    return this;
  }

   /**
   * A structured list of dependencies that this query relies upon. This list is populated by the server from the query text. Each dependency model contains enough information to find the source object.
   * @return dependencies
  **/
  @ApiModelProperty(example = "null", value = "A structured list of dependencies that this query relies upon. This list is populated by the server from the query text. Each dependency model contains enough information to find the source object.")
  public List<QueryDependencyDto> getDependencies() {
    return dependencies;
  }

  public void setDependencies(List<QueryDependencyDto> dependencies) {
    this.dependencies = dependencies;
  }

  public QueryDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The description of the query
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "The description of the query")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public QueryDto historyRevision(Long historyRevision) {
    this.historyRevision = historyRevision;
    return this;
  }

   /**
   * Historical revision number of this entity
   * @return historyRevision
  **/
  @ApiModelProperty(example = "null", value = "Historical revision number of this entity")
  public Long getHistoryRevision() {
    return historyRevision;
  }

  public void setHistoryRevision(Long historyRevision) {
    this.historyRevision = historyRevision;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

   /**
   * If non-null, indicates the last time this query was run.
   * @return lastRun
  **/
  @ApiModelProperty(example = "null", value = "If non-null, indicates the last time this query was run.")
  public DateTime getLastRun() {
    return lastRun;
  }

   /**
   * If non-null, indicates the last user that ran the query.
   * @return lastRunBy
  **/
  @ApiModelProperty(example = "null", value = "If non-null, indicates the last user that ran the query.")
  public String getLastRunBy() {
    return lastRunBy;
  }

  public QueryDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the query
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "The name of the query")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public QueryDto parameters(List<QueryParameterDto> parameters) {
    this.parameters = parameters;
    return this;
  }

  public QueryDto addParametersItem(QueryParameterDto parametersItem) {
    this.parameters.add(parametersItem);
    return this;
  }

   /**
   * The query parameters
   * @return parameters
  **/
  @ApiModelProperty(example = "null", value = "The query parameters")
  public List<QueryParameterDto> getParameters() {
    return parameters;
  }

  public void setParameters(List<QueryParameterDto> parameters) {
    this.parameters = parameters;
  }

   /**
   * If non-null, indicates the parent of this entity. Must be modified through the folder api.
   * @return parentId
  **/
  @ApiModelProperty(example = "null", value = "If non-null, indicates the parent of this entity. Must be modified through the folder api.")
  public String getParentId() {
    return parentId;
  }

  public QueryDto primaryQueryResultId(String primaryQueryResultId) {
    this.primaryQueryResultId = primaryQueryResultId;
    return this;
  }

   /**
   * The identifier of the primary query result
   * @return primaryQueryResultId
  **/
  @ApiModelProperty(example = "null", value = "The identifier of the primary query result")
  public String getPrimaryQueryResultId() {
    return primaryQueryResultId;
  }

  public void setPrimaryQueryResultId(String primaryQueryResultId) {
    this.primaryQueryResultId = primaryQueryResultId;
  }

  public QueryDto queryText(String queryText) {
    this.queryText = queryText;
    return this;
  }

   /**
   * Max size is 30000 characters.  Is required.  Must be a valid DML statement.
   * @return queryText
  **/
  @ApiModelProperty(example = "null", required = true, value = "Max size is 30000 characters.  Is required.  Must be a valid DML statement.")
  public String getQueryText() {
    return queryText;
  }

  public void setQueryText(String queryText) {
    this.queryText = queryText;
  }

  public QueryDto temporary(Boolean temporary) {
    this.temporary = temporary;
    return this;
  }

   /**
   * Denotes if this query is meant to be temporary.  Default is false.
   * @return temporary
  **/
  @ApiModelProperty(example = "false", value = "Denotes if this query is meant to be temporary.  Default is false.")
  public Boolean getTemporary() {
    return temporary;
  }

  public void setTemporary(Boolean temporary) {
    this.temporary = temporary;
  }

  public QueryDto type(String type) {
    this.type = type;
    return this;
  }

   /**
   * This field exists for backwards compatibility only and will always be an empty string.
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "This field exists for backwards compatibility only and will always be an empty string.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryDto queryDto = (QueryDto) o;
    return Objects.equals(this.created, queryDto.created) &&
        Objects.equals(this.definition, queryDto.definition) &&
        Objects.equals(this.dependencies, queryDto.dependencies) &&
        Objects.equals(this.description, queryDto.description) &&
        Objects.equals(this.historyRevision, queryDto.historyRevision) &&
        Objects.equals(this.id, queryDto.id) &&
        Objects.equals(this.lastRun, queryDto.lastRun) &&
        Objects.equals(this.lastRunBy, queryDto.lastRunBy) &&
        Objects.equals(this.name, queryDto.name) &&
        Objects.equals(this.parameters, queryDto.parameters) &&
        Objects.equals(this.parentId, queryDto.parentId) &&
        Objects.equals(this.primaryQueryResultId, queryDto.primaryQueryResultId) &&
        Objects.equals(this.queryText, queryDto.queryText) &&
        Objects.equals(this.temporary, queryDto.temporary) &&
        Objects.equals(this.type, queryDto.type) &&
        Objects.equals(this.updated, queryDto.updated) &&
        Objects.equals(this.userId, queryDto.userId) &&
        Objects.equals(this.version, queryDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, definition, dependencies, description, historyRevision, id, lastRun, lastRunBy, name, parameters, parentId, primaryQueryResultId, queryText, temporary, type, updated, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryDto {\n");
    
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    definition: ").append(toIndentedString(definition)).append("\n");
    sb.append("    dependencies: ").append(toIndentedString(dependencies)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    historyRevision: ").append(toIndentedString(historyRevision)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lastRun: ").append(toIndentedString(lastRun)).append("\n");
    sb.append("    lastRunBy: ").append(toIndentedString(lastRunBy)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    parameters: ").append(toIndentedString(parameters)).append("\n");
    sb.append("    parentId: ").append(toIndentedString(parentId)).append("\n");
    sb.append("    primaryQueryResultId: ").append(toIndentedString(primaryQueryResultId)).append("\n");
    sb.append("    queryText: ").append(toIndentedString(queryText)).append("\n");
    sb.append("    temporary: ").append(toIndentedString(temporary)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

