/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.TableSchema;
import io.swagger.client.model.UniqueConstraintDto;
import java.util.ArrayList;
import java.util.List;
import org.joda.time.DateTime;


/**
 * TableDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-08-12T17:57:42.234Z")
public class TableDto   {
  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("databaseId")
  private String databaseId = null;

  @SerializedName("datasetUpdated")
  private DateTime datasetUpdated = null;

  @SerializedName("deleted")
  private Boolean deleted = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("isShared")
  private Boolean isShared = null;

  @SerializedName("lastUploaded")
  private DateTime lastUploaded = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("parentId")
  private String parentId = null;

  @SerializedName("readOnly")
  private Boolean readOnly = null;

  @SerializedName("tableSchema")
  private TableSchema tableSchema = null;

  /**
   * The type of table
   */
  public enum TypeEnum {
    @SerializedName("data")
    DATA("data"),
    
    @SerializedName("lookup")
    LOOKUP("lookup");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("uniqueTableConstraints")
  private List<UniqueConstraintDto> uniqueTableConstraints = new ArrayList<UniqueConstraintDto>();

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The unique identifier of the database where the table resides.
   * @return databaseId
  **/
  @ApiModelProperty(example = "null", value = "The unique identifier of the database where the table resides.")
  public String getDatabaseId() {
    return databaseId;
  }

  public TableDto datasetUpdated(DateTime datasetUpdated) {
    this.datasetUpdated = datasetUpdated;
    return this;
  }

   /**
   * The last time that the data set for this table was modified.
   * @return datasetUpdated
  **/
  @ApiModelProperty(example = "null", value = "The last time that the data set for this table was modified.")
  public DateTime getDatasetUpdated() {
    return datasetUpdated;
  }

  public void setDatasetUpdated(DateTime datasetUpdated) {
    this.datasetUpdated = datasetUpdated;
  }

   /**
   * This is for backwards compatibility only and will always return false.
   * @return deleted
  **/
  @ApiModelProperty(example = "false", value = "This is for backwards compatibility only and will always return false.")
  public Boolean getDeleted() {
    return deleted;
  }

  public TableDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * May be at most 255 characters in length
   * @return description
  **/
  @ApiModelProperty(example = "null", value = "May be at most 255 characters in length")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

  public TableDto isShared(Boolean isShared) {
    this.isShared = isShared;
    return this;
  }

   /**
   * A property indicating if this table is shared to any destination.
   * @return isShared
  **/
  @ApiModelProperty(example = "false", required = true, value = "A property indicating if this table is shared to any destination.")
  public Boolean getIsShared() {
    return isShared;
  }

  public void setIsShared(Boolean isShared) {
    this.isShared = isShared;
  }

   /**
   * Contains the date and time of the last file that was imported into the table. Valuable for determining if the data is stale.
   * @return lastUploaded
  **/
  @ApiModelProperty(example = "null", value = "Contains the date and time of the last file that was imported into the table. Valuable for determining if the data is stale.")
  public DateTime getLastUploaded() {
    return lastUploaded;
  }

  public TableDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * May be at most 150 characters in length
   * @return name
  **/
  @ApiModelProperty(example = "null", value = "May be at most 150 characters in length")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

   /**
   * If non-null, indicates the parent of this entity. Must be modified through the folder api.
   * @return parentId
  **/
  @ApiModelProperty(example = "null", value = "If non-null, indicates the parent of this entity. Must be modified through the folder api.")
  public String getParentId() {
    return parentId;
  }

   /**
   * Indicates if this table is readonly in the account receiving this table. If so, any attempt to edit the table will fail.
   * @return readOnly
  **/
  @ApiModelProperty(example = "false", value = "Indicates if this table is readonly in the account receiving this table. If so, any attempt to edit the table will fail.")
  public Boolean getReadOnly() {
    return readOnly;
  }

  public TableDto tableSchema(TableSchema tableSchema) {
    this.tableSchema = tableSchema;
    return this;
  }

   /**
   * The schema to apply
   * @return tableSchema
  **/
  @ApiModelProperty(example = "null", value = "The schema to apply")
  public TableSchema getTableSchema() {
    return tableSchema;
  }

  public void setTableSchema(TableSchema tableSchema) {
    this.tableSchema = tableSchema;
  }

  public TableDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * The type of table
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "The type of table")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public TableDto uniqueTableConstraints(List<UniqueConstraintDto> uniqueTableConstraints) {
    this.uniqueTableConstraints = uniqueTableConstraints;
    return this;
  }

  public TableDto addUniqueTableConstraintsItem(UniqueConstraintDto uniqueTableConstraintsItem) {
    this.uniqueTableConstraints.add(uniqueTableConstraintsItem);
    return this;
  }

   /**
   * A property indicating the unique constraints on the table.
   * @return uniqueTableConstraints
  **/
  @ApiModelProperty(example = "null", required = true, value = "A property indicating the unique constraints on the table.")
  public List<UniqueConstraintDto> getUniqueTableConstraints() {
    return uniqueTableConstraints;
  }

  public void setUniqueTableConstraints(List<UniqueConstraintDto> uniqueTableConstraints) {
    this.uniqueTableConstraints = uniqueTableConstraints;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TableDto tableDto = (TableDto) o;
    return Objects.equals(this.created, tableDto.created) &&
        Objects.equals(this.databaseId, tableDto.databaseId) &&
        Objects.equals(this.datasetUpdated, tableDto.datasetUpdated) &&
        Objects.equals(this.deleted, tableDto.deleted) &&
        Objects.equals(this.description, tableDto.description) &&
        Objects.equals(this.id, tableDto.id) &&
        Objects.equals(this.isShared, tableDto.isShared) &&
        Objects.equals(this.lastUploaded, tableDto.lastUploaded) &&
        Objects.equals(this.name, tableDto.name) &&
        Objects.equals(this.parentId, tableDto.parentId) &&
        Objects.equals(this.readOnly, tableDto.readOnly) &&
        Objects.equals(this.tableSchema, tableDto.tableSchema) &&
        Objects.equals(this.type, tableDto.type) &&
        Objects.equals(this.uniqueTableConstraints, tableDto.uniqueTableConstraints) &&
        Objects.equals(this.updated, tableDto.updated) &&
        Objects.equals(this.userId, tableDto.userId) &&
        Objects.equals(this.version, tableDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, databaseId, datasetUpdated, deleted, description, id, isShared, lastUploaded, name, parentId, readOnly, tableSchema, type, uniqueTableConstraints, updated, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TableDto {\n");
    
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    databaseId: ").append(toIndentedString(databaseId)).append("\n");
    sb.append("    datasetUpdated: ").append(toIndentedString(datasetUpdated)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    isShared: ").append(toIndentedString(isShared)).append("\n");
    sb.append("    lastUploaded: ").append(toIndentedString(lastUploaded)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    parentId: ").append(toIndentedString(parentId)).append("\n");
    sb.append("    readOnly: ").append(toIndentedString(readOnly)).append("\n");
    sb.append("    tableSchema: ").append(toIndentedString(tableSchema)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    uniqueTableConstraints: ").append(toIndentedString(uniqueTableConstraints)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

