/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.joda.time.DateTime;


/**
 * TokenDto
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2022-08-12T17:57:42.234Z")
public class TokenDto   {
  @SerializedName("created")
  private DateTime created = null;

  @SerializedName("id")
  private String id = null;

  @SerializedName("objectId")
  private String objectId = null;

  @SerializedName("updated")
  private DateTime updated = null;

  @SerializedName("useFlatKey")
  private Boolean useFlatKey = null;

  @SerializedName("userId")
  private String userId = null;

  @SerializedName("version")
  private Long version = null;

   /**
   * When the entity was created
   * @return created
  **/
  @ApiModelProperty(example = "null", value = "When the entity was created")
  public DateTime getCreated() {
    return created;
  }

   /**
   * The entity's unique identifier
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "The entity's unique identifier")
  public String getId() {
    return id;
  }

  public TokenDto objectId(String objectId) {
    this.objectId = objectId;
    return this;
  }

   /**
   * The object's unique identifier
   * @return objectId
  **/
  @ApiModelProperty(example = "null", value = "The object's unique identifier")
  public String getObjectId() {
    return objectId;
  }

  public void setObjectId(String objectId) {
    this.objectId = objectId;
  }

   /**
   * When the entity was last updated
   * @return updated
  **/
  @ApiModelProperty(example = "null", value = "When the entity was last updated")
  public DateTime getUpdated() {
    return updated;
  }

  public TokenDto useFlatKey(Boolean useFlatKey) {
    this.useFlatKey = useFlatKey;
    return this;
  }

   /**
   * Create token using flat query results key; Ignored unless true.
   * @return useFlatKey
  **/
  @ApiModelProperty(example = "false", value = "Create token using flat query results key; Ignored unless true.")
  public Boolean getUseFlatKey() {
    return useFlatKey;
  }

  public void setUseFlatKey(Boolean useFlatKey) {
    this.useFlatKey = useFlatKey;
  }

   /**
   * The owner of the entity
   * @return userId
  **/
  @ApiModelProperty(example = "null", value = "The owner of the entity")
  public String getUserId() {
    return userId;
  }

   /**
   * The version of the current representation of the entity
   * @return version
  **/
  @ApiModelProperty(example = "null", value = "The version of the current representation of the entity")
  public Long getVersion() {
    return version;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TokenDto tokenDto = (TokenDto) o;
    return Objects.equals(this.created, tokenDto.created) &&
        Objects.equals(this.id, tokenDto.id) &&
        Objects.equals(this.objectId, tokenDto.objectId) &&
        Objects.equals(this.updated, tokenDto.updated) &&
        Objects.equals(this.useFlatKey, tokenDto.useFlatKey) &&
        Objects.equals(this.userId, tokenDto.userId) &&
        Objects.equals(this.version, tokenDto.version);
  }

  @Override
  public int hashCode() {
    return Objects.hash(created, id, objectId, updated, useFlatKey, userId, version);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TokenDto {\n");
    
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    objectId: ").append(toIndentedString(objectId)).append("\n");
    sb.append("    updated: ").append(toIndentedString(updated)).append("\n");
    sb.append("    useFlatKey: ").append(toIndentedString(useFlatKey)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

