/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.BaseResponseOfTokenDto;
import io.swagger.client.model.PagedResponseOfFileMetaDto;
import io.swagger.client.model.BaseResponseOflong;
import java.io.File;
import io.swagger.client.model.BaseResponseOfValidateFilesDto;
import io.swagger.client.model.StartValidateFilesDto;
import io.swagger.client.model.BaseResponseOfValidateTablesDto;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for AdministrativeTasksApi
 */
public class AdministrativeTasksApiTest {

    private final AdministrativeTasksApi api = new AdministrativeTasksApi();

    
    /**
     * Delete a single workspace
     *
     * Deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone&lt;/b&gt;. Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteWorkspaceUsingDELETETest() throws ApiException {
        // BaseResponseOfstring response = api.deleteWorkspaceUsingDELETE();

        // TODO: test validations
    }
    
    /**
     * Export a single workspace
     *
     * Creates a file representing the entirety of the requested workspace and returns a token. Use the [&#x60;Download a single file endpoint&#x60;](ref:wdata-downloadfileusingget) to exchange the token for the file.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void exportWorkspaceUsingGETTest() throws ApiException {
        // BaseResponseOfTokenDto response = api.exportWorkspaceUsingGET();

        // TODO: test validations
    }
    
    /**
     * Retrieve workspace files by size
     *
     * Returns a paged collection of the file meta associated with the workspace of the request, ordered by size.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void findWorkspaceFilesBySizeUsingGETTest() throws ApiException {
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfFileMetaDto response = api.findWorkspaceFilesBySizeUsingGET(limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Retrieve workspace query usage
     *
     * Returns a Long that represents the number of bytes queried by the workspace of the request since the start time provided.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getWorkspaceQueryUsageUsingGETTest() throws ApiException {
        String startDate = null;
        String stopDate = null;
        // BaseResponseOflong response = api.getWorkspaceQueryUsageUsingGET(startDate, stopDate);

        // TODO: test validations
    }
    
    /**
     * Retrieve workspace upload usage
     *
     * Returns a Long that represents the number of bytes uploaded by the workspace associated with this request from the start time provided to now.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getWorkspaceUploadUsageUsingGETTest() throws ApiException {
        String startDate = null;
        String stopDate = null;
        // BaseResponseOflong response = api.getWorkspaceUploadUsageUsingGET(startDate, stopDate);

        // TODO: test validations
    }
    
    /**
     * Import data
     *
     * By default, deletes all information in the workspace of the request. &lt;b&gt;This is a final operation and can&#39;t be undone.&lt;/b&gt;  Any state left in the workspace due to an error is in an indeterminate state and shouldn&#39;t be trusted. Some non-private information may be kept for auditing and metric purposes. After the delete, it then imports the tables, tags, and queries in the provided cb file into the workspace. &lt;br&gt;&lt;br&gt;This is an asynchronous operation. Returns a 201 when the file is correctly decoded and its tables, queries, and tags are saved. Files continue to import after this call completes.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void importDataUsingPOSTTest() throws ApiException {
        File file = null;
        Boolean wipe = null;
        // BaseResponseOfstring response = api.importDataUsingPOST(file, wipe);

        // TODO: test validations
    }
    
    /**
     * Validate files
     *
     * Validates files associated with the provided table ID. Validation repairs any files in an inconsistent state, and deletes those without enough state to recover. All files deleted or repaired are returned.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void validateFilesUsingPOSTTest() throws ApiException {
        StartValidateFilesDto validateFilesDto = null;
        // BaseResponseOfValidateFilesDto response = api.validateFilesUsingPOST(validateFilesDto);

        // TODO: test validations
    }
    
    /**
     * Validate tables
     *
     * Validates the tables in the workspace associated with the request. Validation returns an entity that indicates the tables deleted due to bad state, and those with enough state and repaired.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void validateTablesUsingPOSTTest() throws ApiException {
        // BaseResponseOfValidateTablesDto response = api.validateTablesUsingPOST();

        // TODO: test validations
    }
    
}
