/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.FolderDto;
import io.swagger.client.model.BaseResponseOfFolderDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.PagedResponseOfFolderableDto;
import io.swagger.client.model.PagedResponseOfFolderDto;
import io.swagger.client.model.FolderableDto;
import io.swagger.client.model.BaseResponseOfCollectionOfFolderableDto;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for FolderManagementApi
 */
public class FolderManagementApiTest {

    private final FolderManagementApi api = new FolderManagementApi();

    
    /**
     * Create a new folder
     *
     * Creates a folder using the provided information and returns the folder meta.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createFolderUsingPOSTTest() throws ApiException {
        FolderDto folderDto = null;
        // BaseResponseOfFolderDto response = api.createFolderUsingPOST(folderDto);

        // TODO: test validations
    }
    
    /**
     * Delete a single folder
     *
     * Deletes the folder with the provided ID.  If the folder is not found, this is a no-op. &lt;b&gt;All files and sub-folders are also recursively deleted.&lt;/b&gt;
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteFolderUsingDELETETest() throws ApiException {
        String folderId = null;
        // BaseResponseOfstring response = api.deleteFolderUsingDELETE(folderId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a single folder
     *
     * Returns a folder with the provided ID, or a 404 if no matching folder is found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getFolderUsingGETTest() throws ApiException {
        String folderId = null;
        // BaseResponseOfFolderDto response = api.getFolderUsingGET(folderId);

        // TODO: test validations
    }
    
    /**
     * Retrieve list of folder contents
     *
     * Returns a paged list of all children whose parent ID matches the provided folder ID.  If the folder ID in the path is the literal &#39;null&#39; value, returns a list of all entities with no parent.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listChildrenUsingGETTest() throws ApiException {
        String folderId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfFolderableDto response = api.listChildrenUsingGET(folderId, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Retrieve a list of folders
     *
     * Returns a paged list of all folders associated with the workspace.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listFoldersUsingGETTest() throws ApiException {
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfFolderDto response = api.listFoldersUsingGET(limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Search
     *
     * Returns a list of all entities that match the provided criteria. Both name and description are fuzzy matches; they match _any_ entity that contains the provided string. The type is used to filter results based on the provided type of entity.  The consumer must have READ access on all returned entities.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void searchUsingGETTest() throws ApiException {
        String name = null;
        String description = null;
        List<Integer> type = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfFolderableDto response = api.searchUsingGET(name, description, type, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Move content into a folder
     *
     * Sets the children of a folder using the entities&#39; types and IDs provided in the body. If the entities previously resided under a folder, including the root, they move to the folder with the provided ID. If the provided ID is &#39;null&#39;, the entities move to the root folder.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void setChildrenUsingPOSTTest() throws ApiException {
        String folderId = null;
        List<FolderableDto> children = null;
        // BaseResponseOfCollectionOfFolderableDto response = api.setChildrenUsingPOST(folderId, children);

        // TODO: test validations
    }
    
    /**
     * Update a single folder
     *
     * Updates the folder that matches the provided ID with the details provided in the body.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateFolderUsingPUTTest() throws ApiException {
        String folderId = null;
        FolderDto folderDto = null;
        // BaseResponseOfFolderDto response = api.updateFolderUsingPUT(folderId, folderDto);

        // TODO: test validations
    }
    
}
