/**
 * Cerebral API
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: scoutteam@workiva.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.MultiError;
import io.swagger.client.model.SingleError;
import io.swagger.client.model.BaseResponseOfQueryResultDto;
import io.swagger.client.model.QueryDto;
import io.swagger.client.model.BaseResponseOfQueryDto;
import io.swagger.client.model.BaseResponseOfstring;
import io.swagger.client.model.ExportQueryResultDto;
import io.swagger.client.model.PagedResponseOfTableDto;
import io.swagger.client.model.BaseResponseOfQueryColumnDataDto;
import io.swagger.client.model.QueryTextDto;
import io.swagger.client.model.PagedResponseOfQueryDto;
import io.swagger.client.model.PagedResponseOfQueryResultDto;
import io.swagger.client.model.QueryResultDto;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for QueryManagementApi
 */
public class QueryManagementApiTest {

    private final QueryManagementApi api = new QueryManagementApi();

    
    /**
     * Cancel a running query
     *
     * Cancels a running query based on the provided result ID, and returns a cancelled result unless the query&#39;s already in a COMPLETED state.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void cancelQueryUsingDELETETest() throws ApiException {
        String queryResultId = null;
        // BaseResponseOfQueryResultDto response = api.cancelQueryUsingDELETE(queryResultId);

        // TODO: test validations
    }
    
    /**
     * Create a new query
     *
     * Creates a query object and validates full permissions to ensure the requestor has access to all data sources being queried. This endpoint _doesn&#39;t_ execute the query; to execute, call the POST /queryresult method.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createQueryUsingPOSTTest() throws ApiException {
        QueryDto queryDto = null;
        // BaseResponseOfQueryDto response = api.createQueryUsingPOST(queryDto);

        // TODO: test validations
    }
    
    /**
     * Delete a single query
     *
     * Deletes the query that matches the provided ID. If no such query is found, this is a no-op.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteQueryUsingDELETETest() throws ApiException {
        String queryId = null;
        // BaseResponseOfstring response = api.deleteQueryUsingDELETE(queryId);

        // TODO: test validations
    }
    
    /**
     * Download a query result
     *
     * Uses the Token Management API to create a token with the query result ID, which it then uses to download a CSV file of the query results.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void downloadQueryResultUsingGETTest() throws ApiException {
        String queryResultId = null;
        // byte[] response = api.downloadQueryResultUsingGET(queryResultId);

        // TODO: test validations
    }
    
    /**
     * Export query result to spreadsheets
     *
     * Exports a query result with the provided ID to Spreadsheets. To determine where to export the results, the request body should include a URL copied and pasted from the Spreadsheets UI. Returns a 404 if no matching query result is found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void exportQueryResultToSpreadsheetsUsingPOSTTest() throws ApiException {
        String queryResultId = null;
        ExportQueryResultDto dto = null;
        // BaseResponseOfstring response = api.exportQueryResultToSpreadsheetsUsingPOST(queryResultId, dto);

        // TODO: test validations
    }
    
    /**
     * Retrieve dependencies
     *
     * Returns an unordered collection of all tables the matching query uses as datasources, including any shared tables outside of this OAuth token&#39;s workspace. The endpoint verifies the user has read permissions on the query, but _not_ on the tables returned.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getDependenciesUsingGETTest() throws ApiException {
        String queryId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfTableDto response = api.getDependenciesUsingGET(queryId, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Retrieve query column data
     *
     * Returns a QueryColumnDataDto representing the column data for the given query text. If the query isn&#39;t valid, returns a 400.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getQueryColumnDataUsingPOSTTest() throws ApiException {
        QueryTextDto queryTextDto = null;
        // BaseResponseOfQueryColumnDataDto response = api.getQueryColumnDataUsingPOST(queryTextDto);

        // TODO: test validations
    }
    
    /**
     * Retrieve a single query result
     *
     * Returns a single query result that matches the provided ID, or a 404 if no such query result is found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getQueryResultUsingGETTest() throws ApiException {
        String queryResultId = null;
        // BaseResponseOfQueryResultDto response = api.getQueryResultUsingGET(queryResultId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a single query
     *
     * Returns a query that matches the provided ID, or a 404 if no matching query is found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getQueryUsingGETTest() throws ApiException {
        String queryId = null;
        // BaseResponseOfQueryDto response = api.getQueryUsingGET(queryId);

        // TODO: test validations
    }
    
    /**
     * Retrieve a list of dependents
     *
     * Returns a list of all tables that use the query with provided ID as a datasource. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getTablesDependentOnQueryUsingGETTest() throws ApiException {
        String queryId = null;
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        // PagedResponseOfTableDto response = api.getTablesDependentOnQueryUsingGET(queryId, limit, cursor, offset);

        // TODO: test validations
    }
    
    /**
     * Parses the query to determine if it is valid
     *
     * Returns the provided QueryDto
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void isQueryValidUsingPOSTTest() throws ApiException {
        QueryDto queryDto = null;
        // BaseResponseOfQueryDto response = api.isQueryValidUsingPOST(queryDto);

        // TODO: test validations
    }
    
    /**
     * Retrieve list of queries
     *
     * Returns a list of all non-temporary queries associated with the workspace. By default, these queries are ordered by their names, in ascending order.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listQueriesUsingGETTest() throws ApiException {
        Integer limit = null;
        String cursor = null;
        Long offset = null;
        Object ids = null;
        // PagedResponseOfQueryDto response = api.listQueriesUsingGET(limit, cursor, offset, ids);

        // TODO: test validations
    }
    
    /**
     * Retrieve a list of query results
     *
     * Returns a paged list of query results that match the provided query ID, or an empty list if no matching query is found.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listQueryResultsUsingGETTest() throws ApiException {
        String queryId = null;
        String cursor = null;
        Integer limit = null;
        Long offset = null;
        // PagedResponseOfQueryResultDto response = api.listQueryResultsUsingGET(queryId, cursor, limit, offset);

        // TODO: test validations
    }
    
    /**
     * Preview a query
     *
     * Creates a limited scope query object, but does _not_ execute it. The query selects all values against the provided table, up to 10 rows. This endpoint may allow unpermissioned users to preview table data; full permissions to datasources are _not_ validated.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void previewQueryUsingPOSTTest() throws ApiException {
        String tableId = null;
        Integer limit = null;
        String fileName = null;
        // BaseResponseOfQueryDto response = api.previewQueryUsingPOST(tableId, limit, fileName);

        // TODO: test validations
    }
    
    /**
     * Execute a query
     *
     * Runs a query and immediately returns a query result entity, which has an ID that can be used to poll the status from the GET /queryresult method. A status of COMPLETED or ERROR indicates the query has completed.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void runQueryUsingPOSTTest() throws ApiException {
        QueryResultDto queryResultDto = null;
        // BaseResponseOfQueryResultDto response = api.runQueryUsingPOST(queryResultDto);

        // TODO: test validations
    }
    
    /**
     * Update a single query
     *
     * Updates the query that matches the provided ID with the details provided in the body.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateQueryUsingPUTTest() throws ApiException {
        String queryId = null;
        QueryDto queryDto = null;
        // BaseResponseOfQueryDto response = api.updateQueryUsingPUT(queryId, queryDto);

        // TODO: test validations
    }
    
}
